import{S as Of,i as Gf,s as zf,e as o,k as p,w as m,t as s,M as Ff,c as i,d as n,m as d,a,x as g,h as r,b as c,G as t,g as f,y as u,q as h,o as _,B as v,v as Bf,L as Uf}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as ee}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as k}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as te}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Rf}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Vf(zo){let D,B;return D=new k({props:{code:`import PIL
import requests
import torch
from io import BytesIO

from diffusers import StableDiffusionDiffEditPipeline


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png"

init_image = download_image(img_url).resize((768, 768))

pipe = StableDiffusionDiffEditPipeline.from_pretrained(
    "stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
pipeline.enable_model_cpu_offload()

prompt = "A bowl of fruits"

inverted_latents = pipe.invert(image=init_image, prompt=prompt).latents`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> PIL
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionDiffEditPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
<span class="hljs-meta">... </span>    response = requests.get(url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>img_url = <span class="hljs-string">&quot;https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = download_image(img_url).resize((<span class="hljs-number">768</span>, <span class="hljs-number">768</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionDiffEditPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A bowl of fruits&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inverted_latents = pipe.invert(image=init_image, prompt=prompt).latents`}}),{c(){m(D.$$.fragment)},l(y){g(D.$$.fragment,y)},m(y,L){u(D,y,L),B=!0},p:Uf,i(y){B||(h(D.$$.fragment,y),B=!0)},o(y){_(D.$$.fragment,y),B=!1},d(y){v(D,y)}}}function Hf(zo){let D,B,y,L,un,Ee,wa,hn,ya,Fo,U,ne,_n,ke,Ea,vn,ka,Bo,De,$e,Da,$a,Uo,jt,xa,Ro,Tt,bn,Pa,Vo,qt,Ia,Ho,C,Lt,xe,Sa,ja,Ta,Ct,Pe,qa,La,Ca,At,Ie,Aa,Na,Wo,R,oe,wn,Se,Ma,yn,Oa,Xo,E,En,Ga,za,j,Fa,kn,Ba,Ua,Dn,Ra,Va,$n,Ha,Wa,Xa,$,Ka,xn,Za,Ja,Pn,Ya,Qa,In,es,ts,Sn,ns,os,jn,is,as,ss,T,rs,Tn,ls,ps,qn,ds,fs,Nt,cs,ms,gs,P,us,Ln,hs,_s,Cn,vs,bs,An,ws,ys,Nn,Es,ks,Ds,Mt,$s,V,q,xs,Mn,Ps,Is,On,Ss,js,Gn,Ts,qs,Ls,je,Cs,zn,As,Ns,Ms,H,Os,Fn,Gs,zs,Bn,Fs,Bs,Us,Te,Rs,Ot,Vs,Hs,Ko,W,ie,Un,qe,Ws,Rn,Xs,Zo,ae,Vn,Le,Hn,Ks,Zs,Wn,Js,Ys,Xn,Ce,Kn,Ae,Qs,er,Zn,Jn,tr,Jo,X,se,Yn,Ne,nr,Qn,or,Yo,K,re,eo,Me,ir,to,ar,Qo,le,sr,no,rr,lr,ei,Gt,pr,ti,Oe,ni,zt,dr,oi,Ge,ii,Ft,fr,ai,ze,si,Bt,cr,ri,Fe,li,Ut,mr,pi,Be,di,Z,pe,oo,Ue,gr,io,ur,fi,de,hr,Re,_r,vr,ci,Rt,br,mi,Ve,gi,Vt,wr,ui,He,hi,Ht,yr,_i,We,vi,Wt,Er,bi,Xe,wi,Xt,kr,yi,Ke,Ei,J,fe,ao,Ze,Dr,so,$r,ki,ce,xr,Je,Pr,Ir,Di,Ye,ro,Sr,jr,$i,Qe,xi,et,lo,Tr,qr,Pi,tt,Ii,Kt,Lr,Si,nt,po,Cr,Ar,ji,Zt,Nr,Ti,ot,qi,Jt,Mr,Li,it,Ci,A,Or,fo,Gr,zr,at,Fr,Br,Ai,st,co,Ur,Rr,Ni,Yt,Vr,Mi,rt,Oi,lt,mo,Hr,Wr,Gi,pt,zi,Qt,Xr,Fi,dt,Bi,Y,me,go,ft,Kr,uo,Zr,Ui,b,ct,Jr,mt,Yr,ho,Qr,el,tl,gt,nl,en,ol,il,al,_o,sl,rl,ut,ht,vo,ll,pl,tn,dl,fl,_t,bo,cl,ml,nn,gl,ul,wo,hl,_l,yo,vt,Eo,vl,bl,on,wl,yl,N,bt,El,ko,kl,Dl,Do,$l,xl,M,wt,Pl,$o,Il,Sl,ge,jl,ue,yt,Tl,Et,ql,xo,Ll,Cl,Al,he,kt,Nl,Dt,Ml,Po,Ol,Gl,zl,_e,$t,Fl,I,Bl,Io,Ul,Rl,So,Vl,Hl,jo,Wl,Xl,To,Kl,Zl,Jl,ve,xt,Yl,Q,Ql,qo,ep,tp,Lo,np,op,ip,O,Pt,ap,Co,sp,rp,Ao,lp,pp,G,It,dp,No,fp,cp,Mo,mp,Ri,an,Oo,Go,gp,Vi;return Ee=new te({}),ke=new te({}),Se=new te({}),qe=new te({}),Ne=new te({}),Me=new te({}),Oe=new k({props:{code:`import torch
from diffusers import DDIMScheduler, DDIMInverseScheduler, StableDiffusionPix2PixZeroPipeline

sd_model_ckpt = "stabilityai/stable-diffusion-2-1"
pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    sd_model_ckpt,
    torch_dtype=torch.float16,
    safety_checker=None,
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()
generator = torch.manual_seed(0)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, DDIMInverseScheduler, StableDiffusionPix2PixZeroPipeline

sd_model_ckpt = <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>
pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    sd_model_ckpt,
    torch_dtype=torch.float16,
    safety_checker=<span class="hljs-literal">None</span>,
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()
generator = torch.manual_seed(<span class="hljs-number">0</span>)`}}),Ge=new k({props:{code:`from diffusers.utils import load_image

img_url = "https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png"
raw_image = load_image(img_url).convert("RGB").resize((768, 768))`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

img_url = <span class="hljs-string">&quot;https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png&quot;</span>
raw_image = load_image(img_url).convert(<span class="hljs-string">&quot;RGB&quot;</span>).resize((<span class="hljs-number">768</span>, <span class="hljs-number">768</span>))`}}),ze=new k({props:{code:`# See the "Generating source and target embeddings" section below to
# automate the generation of these captions with a pre-trained model like Flan-T5 as explained below.

source_prompt = "a bowl of fruits"
target_prompt = "a basket of fruits"
mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt=source_prompt,
    target_prompt=target_prompt,
    generator=generator,
)`,highlighted:`<span class="hljs-comment"># See the &quot;Generating source and target embeddings&quot; section below to</span>
<span class="hljs-comment"># automate the generation of these captions with a pre-trained model like Flan-T5 as explained below.</span>

source_prompt = <span class="hljs-string">&quot;a bowl of fruits&quot;</span>
target_prompt = <span class="hljs-string">&quot;a basket of fruits&quot;</span>
mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt=source_prompt,
    target_prompt=target_prompt,
    generator=generator,
)`}}),Fe=new k({props:{code:"inv_latents = pipeline.invert(prompt=source_prompt, image=raw_image, generator=generator).latents",highlighted:"inv_latents = pipeline.invert(prompt=source_prompt, image=raw_image, generator=generator).latents"}}),Be=new k({props:{code:`image = pipeline(
    prompt=target_prompt,
    mask_image=mask_image,
    image_latents=inv_latents,
    generator=generator,
    negative_prompt=source_prompt,
).images[0]
image.save("edited_image.png")`,highlighted:`image = pipeline(
    prompt=target_prompt,
    mask_image=mask_image,
    image_latents=inv_latents,
    generator=generator,
    negative_prompt=source_prompt,
).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;edited_image.png&quot;</span>)`}}),Ue=new te({}),Ve=new k({props:{code:`import torch
from transformers import BlipForConditionalGeneration, BlipProcessor

captioner_id = "Salesforce/blip-image-captioning-base"
processor = BlipProcessor.from_pretrained(captioner_id)
model = BlipForConditionalGeneration.from_pretrained(captioner_id, torch_dtype=torch.float16, low_cpu_mem_usage=True)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BlipForConditionalGeneration, BlipProcessor

captioner_id = <span class="hljs-string">&quot;Salesforce/blip-image-captioning-base&quot;</span>
processor = BlipProcessor.from_pretrained(captioner_id)
model = BlipForConditionalGeneration.from_pretrained(captioner_id, torch_dtype=torch.float16, low_cpu_mem_usage=<span class="hljs-literal">True</span>)`}}),He=new k({props:{code:`@torch.no_grad()
def generate_caption(images, caption_generator, caption_processor):
    text = "a photograph of"

    inputs = caption_processor(images, text, return_tensors="pt").to(device="cuda", dtype=caption_generator.dtype)
    caption_generator.to("cuda")
    outputs = caption_generator.generate(**inputs, max_new_tokens=128)

    # offload caption generator
    caption_generator.to("cpu")

    caption = caption_processor.batch_decode(outputs, skip_special_tokens=True)[0]
    return caption`,highlighted:`<span class="hljs-meta">@torch.no_grad()</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_caption</span>(<span class="hljs-params">images, caption_generator, caption_processor</span>):
    text = <span class="hljs-string">&quot;a photograph of&quot;</span>

    inputs = caption_processor(images, text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device=<span class="hljs-string">&quot;cuda&quot;</span>, dtype=caption_generator.dtype)
    caption_generator.to(<span class="hljs-string">&quot;cuda&quot;</span>)
    outputs = caption_generator.generate(**inputs, max_new_tokens=<span class="hljs-number">128</span>)

    <span class="hljs-comment"># offload caption generator</span>
    caption_generator.to(<span class="hljs-string">&quot;cpu&quot;</span>)

    caption = caption_processor.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]
    <span class="hljs-keyword">return</span> caption`}}),We=new k({props:{code:`from diffusers.utils import load_image

img_url = "https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png"
raw_image = load_image(img_url).convert("RGB").resize((768, 768))
caption = generate_caption(raw_image, model, processor)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

img_url = <span class="hljs-string">&quot;https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png&quot;</span>
raw_image = load_image(img_url).convert(<span class="hljs-string">&quot;RGB&quot;</span>).resize((<span class="hljs-number">768</span>, <span class="hljs-number">768</span>))
caption = generate_caption(raw_image, model, processor)`}}),Xe=new k({props:{code:`from diffusers import DDIMInverseScheduler, DDIMScheduler

pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    "stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16
)
pipeline = pipeline.to("cuda")
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)

generator = torch.manual_seed(0)
inv_latents = pipeline.invert(prompt=caption, image=raw_image, generator=generator).latents`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMInverseScheduler, DDIMScheduler

pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16
)
pipeline = pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)

generator = torch.manual_seed(<span class="hljs-number">0</span>)
inv_latents = pipeline.invert(prompt=caption, image=raw_image, generator=generator).latents`}}),Ke=new k({props:{code:`source_prompt = "a bowl of fruits"
target_prompt = "a basket of fruits"

mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt=source_prompt,
    target_prompt=target_prompt,
    generator=generator,
)

image = pipeline(
    prompt=target_prompt,
    mask_image=mask_image,
    image_latents=inv_latents,
    generator=generator,
    negative_prompt=source_prompt,
).images[0]
image.save("edited_image.png")`,highlighted:`source_prompt = <span class="hljs-string">&quot;a bowl of fruits&quot;</span>
target_prompt = <span class="hljs-string">&quot;a basket of fruits&quot;</span>

mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt=source_prompt,
    target_prompt=target_prompt,
    generator=generator,
)

image = pipeline(
    prompt=target_prompt,
    mask_image=mask_image,
    image_latents=inv_latents,
    generator=generator,
    negative_prompt=source_prompt,
).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;edited_image.png&quot;</span>)`}}),Ze=new te({}),Qe=new k({props:{code:`import torch
from transformers import AutoTokenizer, T5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("google/flan-t5-xl")
model = T5ForConditionalGeneration.from_pretrained("google/flan-t5-xl", device_map="auto", torch_dtype=torch.float16)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, T5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;google/flan-t5-xl&quot;</span>)
model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;google/flan-t5-xl&quot;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, torch_dtype=torch.float16)`}}),tt=new k({props:{code:`source_concept = "bowl"
target_concept = "basket"

source_text = f"Provide a caption for images containing a {source_concept}. "
"The captions should be in English and should be no longer than 150 characters."

target_text = f"Provide a caption for images containing a {target_concept}. "
"The captions should be in English and should be no longer than 150 characters."`,highlighted:`source_concept = <span class="hljs-string">&quot;bowl&quot;</span>
target_concept = <span class="hljs-string">&quot;basket&quot;</span>

source_text = <span class="hljs-string">f&quot;Provide a caption for images containing a <span class="hljs-subst">{source_concept}</span>. &quot;</span>
<span class="hljs-string">&quot;The captions should be in English and should be no longer than 150 characters.&quot;</span>

target_text = <span class="hljs-string">f&quot;Provide a caption for images containing a <span class="hljs-subst">{target_concept}</span>. &quot;</span>
<span class="hljs-string">&quot;The captions should be in English and should be no longer than 150 characters.&quot;</span>`}}),ot=new k({props:{code:`@torch.no_grad
def generate_prompts(input_prompt):
    input_ids = tokenizer(input_prompt, return_tensors="pt").input_ids.to("cuda")

    outputs = model.generate(
        input_ids, temperature=0.8, num_return_sequences=16, do_sample=True, max_new_tokens=128, top_k=10
    )
    return tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-meta">@torch.no_grad</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_prompts</span>(<span class="hljs-params">input_prompt</span>):
    input_ids = tokenizer(input_prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids.to(<span class="hljs-string">&quot;cuda&quot;</span>)

    outputs = model.generate(
        input_ids, temperature=<span class="hljs-number">0.8</span>, num_return_sequences=<span class="hljs-number">16</span>, do_sample=<span class="hljs-literal">True</span>, max_new_tokens=<span class="hljs-number">128</span>, top_k=<span class="hljs-number">10</span>
    )
    <span class="hljs-keyword">return</span> tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)`}}),it=new k({props:{code:`source_prompts = generate_prompts(source_text)
target_prompts = generate_prompts(target_text)`,highlighted:`source_prompts = generate_prompts(source_text)
target_prompts = generate_prompts(target_text)`}}),rt=new k({props:{code:`from diffusers import StableDiffusionDiffEditPipeline 

pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    "stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16
)
pipeline = pipeline.to("cuda")
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()

generator = torch.manual_seed(0)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionDiffEditPipeline 

pipeline = StableDiffusionDiffEditPipeline.from_pretrained(
    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16
)
pipeline = pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)
pipeline.enable_model_cpu_offload()
pipeline.enable_vae_slicing()

generator = torch.manual_seed(<span class="hljs-number">0</span>)`}}),pt=new k({props:{code:`import torch 

@torch.no_grad()
def embed_prompts(sentences, tokenizer, text_encoder, device="cuda"):
    embeddings = []
    for sent in sentences:
        text_inputs = tokenizer(
            sent,
            padding="max_length",
            max_length=tokenizer.model_max_length,
            truncation=True,
            return_tensors="pt",
        )
        text_input_ids = text_inputs.input_ids
        prompt_embeds = text_encoder(text_input_ids.to(device), attention_mask=None)[0]
        embeddings.append(prompt_embeds)
    return torch.concatenate(embeddings, dim=0).mean(dim=0).unsqueeze(0)

source_embeddings = embed_prompts(source_prompts, pipeline.tokenizer, pipeline.text_encoder)
target_embeddings = embed_prompts(target_captions, pipeline.tokenizer, pipeline.text_encoder)`,highlighted:`<span class="hljs-keyword">import</span> torch 

<span class="hljs-meta">@torch.no_grad()</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">embed_prompts</span>(<span class="hljs-params">sentences, tokenizer, text_encoder, device=<span class="hljs-string">&quot;cuda&quot;</span></span>):
    embeddings = []
    <span class="hljs-keyword">for</span> sent <span class="hljs-keyword">in</span> sentences:
        text_inputs = tokenizer(
            sent,
            padding=<span class="hljs-string">&quot;max_length&quot;</span>,
            max_length=tokenizer.model_max_length,
            truncation=<span class="hljs-literal">True</span>,
            return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
        )
        text_input_ids = text_inputs.input_ids
        prompt_embeds = text_encoder(text_input_ids.to(device), attention_mask=<span class="hljs-literal">None</span>)[<span class="hljs-number">0</span>]
        embeddings.append(prompt_embeds)
    <span class="hljs-keyword">return</span> torch.concatenate(embeddings, dim=<span class="hljs-number">0</span>).mean(dim=<span class="hljs-number">0</span>).unsqueeze(<span class="hljs-number">0</span>)

source_embeddings = embed_prompts(source_prompts, pipeline.tokenizer, pipeline.text_encoder)
target_embeddings = embed_prompts(target_captions, pipeline.tokenizer, pipeline.text_encoder)`}}),dt=new k({props:{code:`from diffusers import DDIMInverseScheduler, DDIMScheduler
from diffusers.utils import load_image

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)

img_url = "https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png"
raw_image = load_image(img_url).convert("RGB").resize((768, 768))


mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt_embeds=source_embeds,
    target_prompt_embeds=target_embeds,
    generator=generator,
)

inv_latents = pipeline.invert(
    prompt_embeds=source_embeds,
    image=raw_image,
    generator=generator,
).latents

images = pipeline(
    mask_image=mask_image,
    image_latents=inv_latents,
    prompt_embeds=target_embeddings,
    negative_prompt_embeds=source_embeddings,
    generator=generator,
).images
images[0].save("edited_image.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMInverseScheduler, DDIMScheduler
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)

img_url = <span class="hljs-string">&quot;https://github.com/Xiang-cd/DiffEdit-stable-diffusion/raw/main/assets/origin.png&quot;</span>
raw_image = load_image(img_url).convert(<span class="hljs-string">&quot;RGB&quot;</span>).resize((<span class="hljs-number">768</span>, <span class="hljs-number">768</span>))


mask_image = pipeline.generate_mask(
    image=raw_image,
    source_prompt_embeds=source_embeds,
    target_prompt_embeds=target_embeds,
    generator=generator,
)

inv_latents = pipeline.invert(
    prompt_embeds=source_embeds,
    image=raw_image,
    generator=generator,
).latents

images = pipeline(
    mask_image=mask_image,
    image_latents=inv_latents,
    prompt_embeds=target_embeddings,
    negative_prompt_embeds=source_embeddings,
    generator=generator,
).images
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image.png&quot;</span>)`}}),ft=new te({}),ct=new ee({props:{name:"class diffusers.StableDiffusionDiffEditPipeline",anchor:"diffusers.StableDiffusionDiffEditPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"inverse_scheduler",val:": DDIMInverseScheduler"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDiffEditPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2352/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2352/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2352/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.inverse_scheduler",description:`<strong>inverse_scheduler</strong> (<code>[DDIMInverseScheduler]</code>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to fill in the unmasked part of the input latents`,name:"inverse_scheduler"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L233"}}),bt=new ee({props:{name:"generate_mask",anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask",parameters:[{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"target_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"target_negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"target_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"target_negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"source_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"source_negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"source_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"source_negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"num_maps_per_mask",val:": typing.Optional[int] = 10"},{name:"mask_encode_strength",val:": typing.Optional[float] = 0.5"},{name:"mask_thresholding_ratio",val:": typing.Optional[float] = 3.0"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"output_type",val:": typing.Optional[str] = 'np'"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch which will be used for computing the mask.`,name:"image"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.target_prompt",description:`<strong>target_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the semantic mask generation. If not defined, one has to pass
<code>prompt_embeds</code>. instead.`,name:"target_prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.target_negative_prompt",description:`<strong>target_negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"target_negative_prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.target_prompt_embeds",description:`<strong>target_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"target_prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.target_negative_prompt_embeds",description:`<strong>target_negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"target_negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.source_prompt",description:`<strong>source_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the semantic mask generation using the method in <a href="https://arxiv.org/pdf/2210.11427.pdf" rel="nofollow">DiffEdit:
Diffusion-Based Semantic Image Editing with Mask Guidance</a>. If
not defined, one has to pass <code>source_prompt_embeds</code> or <code>source_image</code> instead.`,name:"source_prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.source_negative_prompt",description:`<strong>source_negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the semantic mask generation away from using the method in <a href="https://arxiv.org/pdf/2210.11427.pdf" rel="nofollow">DiffEdit:
Diffusion-Based Semantic Image Editing with Mask Guidance</a>. If
not defined, one has to pass <code>source_negative_prompt_embeds</code> or <code>source_image</code> instead.`,name:"source_negative_prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.source_prompt_embeds",description:`<strong>source_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings to guide the semantic mask generation. Can be used to easily tweak text
inputs, <em>e.g.</em> prompt weighting. If not provided, text embeddings will be generated from
<code>source_prompt</code> input argument.`,name:"source_prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.source_negative_prompt_embeds",description:`<strong>source_negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings to negatively guide the semantic mask generation. Can be used to easily
tweak text inputs, <em>e.g.</em> prompt weighting. If not provided, text embeddings will be generated from
<code>source_negative_prompt</code> input argument.`,name:"source_negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.num_maps_per_mask",description:`<strong>num_maps_per_mask</strong> (<code>int</code>, <em>optional</em>, defaults to 10) &#x2014;
The number of noise maps sampled to generate the semantic mask using the method in <a href="https://arxiv.org/pdf/2210.11427.pdf" rel="nofollow">DiffEdit:
Diffusion-Based Semantic Image Editing with Mask Guidance</a>.`,name:"num_maps_per_mask"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.mask_encode_strength",description:`<strong>mask_encode_strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Conceptually, the strength of the noise maps sampled to generate the semantic mask using the method in
<a href="https://arxiv.org/pdf/2210.11427.pdf" rel="nofollow">DiffEdit: Diffusion-Based Semantic Image Editing with Mask Guidance</a>. Must be between 0 and 1.`,name:"mask_encode_strength"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.mask_thresholding_ratio",description:`<strong>mask_thresholding_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 3.0) &#x2014;
The maximum multiple of the mean absolute difference used to clamp the semantic guidance map before
mask binarization.`,name:"mask_thresholding_ratio"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.generate_mask.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L842",returnDescription:`
<p><code>List[PIL.Image.Image]</code> if <code>output_type</code> is <code>"pil"</code>, otherwise a
<code>np.array</code>. When returning a <code>List[PIL.Image.Image]</code>, the list will consist of a batch of single-channel
binary image with dimensions <code>(height // self.vae_scale_factor, width // self.vae_scale_factor)</code>, otherwise
the <code>np.array</code> will have shape <code>(batch_size, height // self.vae_scale_factor, width // self.vae_scale_factor)</code>.</p>
`,returnType:`
<p><code>List[PIL.Image.Image]</code> or <code>np.array</code></p>
`}}),wt=new ee({props:{name:"invert",anchor:"diffusers.StableDiffusionDiffEditPipeline.invert",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"inpaint_strength",val:": float = 0.8"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decode_latents",val:": bool = False"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"lambda_auto_corr",val:": float = 20.0"},{name:"lambda_kl",val:": float = 20.0"},{name:"num_reg_steps",val:": int = 0"},{name:"num_auto_corr_rolls",val:": int = 5"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch to produce the inverted latents, guided by <code>prompt</code>.`,name:"image"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.inpaint_strength",description:`<strong>inpaint_strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how far into the noising process to run latent inversion. Must be between 0 and<ol>
<li>When <code>strength</code> is 1, the inversion process will be run for the full number of iterations specified
in <code>num_inference_steps</code>. <code>image</code> will be used as a reference for the inversion process, adding more
noise the larger the <code>strength</code>. If <code>strength</code> is 0, no inpainting will occur.</li>
</ol>`,name:"inpaint_strength"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.decode_latents",description:`<strong>decode_latents</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to decode the inverted latents into a generated image. Setting this argument to <code>True</code>
will decode all inverted latents for each timestep into a list of generated images.`,name:"decode_latents"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.DiffEditInversionPipelineOutput</code> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.lambda_auto_corr",description:`<strong>lambda_auto_corr</strong> (<code>float</code>, <em>optional</em>, defaults to 20.0) &#x2014;
Lambda parameter to control auto correction`,name:"lambda_auto_corr"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.lambda_kl",description:`<strong>lambda_kl</strong> (<code>float</code>, <em>optional</em>, defaults to 20.0) &#x2014;
Lambda parameter to control Kullback&#x2013;Leibler divergence output`,name:"lambda_kl"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.num_reg_steps",description:`<strong>num_reg_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
Number of regularization loss steps`,name:"num_reg_steps"},{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.num_auto_corr_rolls",description:`<strong>num_auto_corr_rolls</strong> (<code>int</code>, <em>optional</em>, defaults to 5) &#x2014;
Number of auto correction roll steps`,name:"num_auto_corr_rolls"}],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L1063",returnDescription:`
<p><code>DiffEditInversionPipelineOutput</code> or
<code>tuple</code>: <code>DiffEditInversionPipelineOutput</code>
if <code>return_dict</code> is <code>True</code>, otherwise a <code>tuple</code>. When returning a tuple, the first element is the inverted
latents tensors ordered by increasing noise, and then second is the corresponding decoded images if
<code>decode_latents</code> is <code>True</code>, otherwise <code>None</code>.</p>
`}}),ge=new Rf({props:{anchor:"diffusers.StableDiffusionDiffEditPipeline.invert.example",$$slots:{default:[Vf]},$$scope:{ctx:zo}}}),yt=new ee({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionDiffEditPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L373"}}),kt=new ee({props:{name:"disable_vae_tiling",anchor:"diffusers.StableDiffusionDiffEditPipeline.disable_vae_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L391"}}),$t=new ee({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionDiffEditPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L425"}}),xt=new ee({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionDiffEditPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L399"}}),Pt=new ee({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionDiffEditPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L363"}}),It=new ee({props:{name:"enable_vae_tiling",anchor:"diffusers.StableDiffusionDiffEditPipeline.enable_vae_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2352/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py#L381"}}),{c(){D=o("meta"),B=p(),y=o("h1"),L=o("a"),un=o("span"),m(Ee.$$.fragment),wa=p(),hn=o("span"),ya=s("Zero-shot Diffusion-based Semantic Image Editing with Mask Guidance"),Fo=p(),U=o("h2"),ne=o("a"),_n=o("span"),m(ke.$$.fragment),Ea=p(),vn=o("span"),ka=s("Overview"),Bo=p(),De=o("p"),$e=o("a"),Da=s("DiffEdit: Diffusion-based semantic image editing with mask guidance"),$a=s(" by Guillaume Couairon, Jakob Verbeek, Holger Schwenk, and Matthieu Cord."),Uo=p(),jt=o("p"),xa=s("The abstract of the paper is the following:"),Ro=p(),Tt=o("p"),bn=o("em"),Pa=s("Image generation has recently seen tremendous advances, with diffusion models allowing to synthesize convincing images for a large variety of text prompts. In this article, we propose DiffEdit, a method to take advantage of text-conditioned diffusion models for the task of semantic image editing, where the goal is to edit an image based on a text query. Semantic image editing is an extension of image generation, with the additional constraint that the generated image should be as similar as possible to a given input image. Current editing methods based on diffusion models usually require to provide a mask, making the task much easier by treating it as a conditional inpainting task. In contrast, our main contribution is able to automatically generate a mask highlighting regions of the input image that need to be edited, by contrasting predictions of a diffusion model conditioned on different text prompts. Moreover, we rely on latent inference to preserve content in those regions of interest and show excellent synergies with mask-based diffusion. DiffEdit achieves state-of-the-art editing performance on ImageNet. In addition, we evaluate semantic image editing in more challenging settings, using images from the COCO dataset as well as text-based generated images."),Vo=p(),qt=o("p"),Ia=s("Resources:"),Ho=p(),C=o("ul"),Lt=o("li"),xe=o("a"),Sa=s("Paper"),ja=s("."),Ta=p(),Ct=o("li"),Pe=o("a"),qa=s("Blog Post with Demo"),La=s("."),Ca=p(),At=o("li"),Ie=o("a"),Aa=s("Implementation on Github"),Na=s("."),Wo=p(),R=o("h2"),oe=o("a"),wn=o("span"),m(Se.$$.fragment),Ma=p(),yn=o("span"),Oa=s("Tips"),Xo=p(),E=o("ul"),En=o("li"),Ga=s("The pipeline can generate masks that can be fed into other inpainting pipelines. Check out the code examples below to know more."),za=p(),j=o("li"),Fa=s("In order to generate an image using this pipeline, both an image mask (manually specified or generated using "),kn=o("code"),Ba=s("generate_mask"),Ua=s(`)
and a set of partially inverted latents (generated using `),Dn=o("code"),Ra=s("invert"),Va=s(") "),$n=o("em"),Ha=s("must"),Wa=s(` be provided as arguments when calling the pipeline to generate the final edited image.
Refer to the code examples below for more details.`),Xa=p(),$=o("li"),Ka=s("The function "),xn=o("code"),Za=s("generate_mask"),Ja=s(" exposes two prompt arguments, "),Pn=o("code"),Ya=s("source_prompt"),Qa=s(" and "),In=o("code"),es=s("target_prompt"),ts=s(`,
that let you control the locations of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the generated mask, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Sn=o("code"),ns=s("source_prompt_embeds"),os=s(" and \u201Cdog\u201D to "),jn=o("code"),is=s("target_prompt_embeds"),as=s(". Refer to the code example below for more details."),ss=p(),T=o("li"),rs=s("When generating partially inverted latents using "),Tn=o("code"),ls=s("invert"),ps=s(`, assign a caption or text embedding describing the
overall image to the `),qn=o("code"),ds=s("prompt"),fs=s(` argument to help guide the inverse latent sampling process. In most cases, the
source concept is sufficently descriptive to yield good results, but feel free to explore alternatives.
Please refer to `),Nt=o("a"),cs=s("this code example"),ms=s(" for more details."),gs=p(),P=o("li"),us=s("When calling the pipeline to generate the final edited image, assign the source concept to "),Ln=o("code"),hs=s("negative_prompt"),_s=s(`
and the target concept to `),Cn=o("code"),vs=s("prompt"),bs=s(`. Taking the above example, you simply have to set the embeddings related to
the phrases including \u201Ccat\u201D to `),An=o("code"),ws=s("negative_prompt_embeds"),ys=s(" and \u201Cdog\u201D to "),Nn=o("code"),Es=s("prompt_embeds"),ks=s(`. Refer to the code example
below for more details.`),Ds=p(),Mt=o("li"),$s=s("If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),V=o("ul"),q=o("li"),xs=s("Swap the "),Mn=o("code"),Ps=s("source_prompt"),Is=s(" and "),On=o("code"),Ss=s("target_prompt"),js=s(" in the arguments to "),Gn=o("code"),Ts=s("generate_mask"),qs=s("."),Ls=p(),je=o("li"),Cs=s("Change the input prompt for "),zn=o("code"),As=s("invert"),Ns=s(" to include \u201Cdog\u201D."),Ms=p(),H=o("li"),Os=s("Swap the "),Fn=o("code"),Gs=s("prompt"),zs=s(" and "),Bn=o("code"),Fs=s("negative_prompt"),Bs=s(" in the arguments to call the pipeline to generate the final edited image."),Us=p(),Te=o("li"),Rs=s("Note that the source and target prompts, or their corresponding embeddings, can also be automatically generated. Please, refer to "),Ot=o("a"),Vs=s("this discussion"),Hs=s(" for more details."),Ko=p(),W=o("h2"),ie=o("a"),Un=o("span"),m(qe.$$.fragment),Ws=p(),Rn=o("span"),Xs=s("Available Pipelines:"),Zo=p(),ae=o("table"),Vn=o("thead"),Le=o("tr"),Hn=o("th"),Ks=s("Pipeline"),Zs=p(),Wn=o("th"),Js=s("Tasks"),Ys=p(),Xn=o("tbody"),Ce=o("tr"),Kn=o("td"),Ae=o("a"),Qs=s("StableDiffusionDiffEditPipeline"),er=p(),Zn=o("td"),Jn=o("em"),tr=s("Text-Based Image Editing"),Jo=p(),X=o("h2"),se=o("a"),Yn=o("span"),m(Ne.$$.fragment),nr=p(),Qn=o("span"),or=s("Usage example"),Yo=p(),K=o("h3"),re=o("a"),eo=o("span"),m(Me.$$.fragment),ir=p(),to=o("span"),ar=s("Based on an input image with a caption"),Qo=p(),le=o("p"),sr=s(`When the pipeline is conditioned on an input image, we first obtain partially inverted latents from the input image using a
`),no=o("code"),rr=s("DDIMInverseScheduler"),lr=s(` with the help of a caption. Then we generate an editing mask to identify relevant regions in the image using the source and target prompts. Finally,
the inverted noise and generated mask is used to start the generation process.`),ei=p(),Gt=o("p"),pr=s("First, let\u2019s load our pipeline:"),ti=p(),m(Oe.$$.fragment),ni=p(),zt=o("p"),dr=s("Then, we load an input image to edit using our method:"),oi=p(),m(Ge.$$.fragment),ii=p(),Ft=o("p"),fr=s("Then, we employ the source and target prompts to generate the editing mask:"),ai=p(),m(ze.$$.fragment),si=p(),Bt=o("p"),cr=s("Then, we employ the caption and the input image to get the inverted latents:"),ri=p(),m(Fe.$$.fragment),li=p(),Ut=o("p"),mr=s("Now, generate the image with the inverted latents and semantically generated mask:"),pi=p(),m(Be.$$.fragment),di=p(),Z=o("h2"),pe=o("a"),oo=o("span"),m(Ue.$$.fragment),gr=p(),io=o("span"),ur=s("Generating image captions for inversion"),fi=p(),de=o("p"),hr=s(`The authors originally used the source concept prompt as the caption for generating the partially inverted latents. However, we can also leverage open source and public image captioning models for the same purpose.
Below, we provide an end-to-end example with the `),Re=o("a"),_r=s("BLIP"),vr=s(` model
for generating captions.`),ci=p(),Rt=o("p"),br=s("First, let\u2019s load our automatic image captioning model:"),mi=p(),m(Ve.$$.fragment),gi=p(),Vt=o("p"),wr=s("Then, we define a utility to generate captions from an input image using the model:"),ui=p(),m(He.$$.fragment),hi=p(),Ht=o("p"),yr=s("Then, we load an input image for conditioning and obtain a suitable caption for it:"),_i=p(),m(We.$$.fragment),vi=p(),Wt=o("p"),Er=s("Then, we employ the generated caption and the input image to get the inverted latents:"),bi=p(),m(Xe.$$.fragment),wi=p(),Xt=o("p"),kr=s("Now, generate the image with the inverted latents and semantically generated mask from our source and target prompts:"),yi=p(),m(Ke.$$.fragment),Ei=p(),J=o("h2"),fe=o("a"),ao=o("span"),m(Ze.$$.fragment),Dr=p(),so=o("span"),$r=s("Generating source and target embeddings"),ki=p(),ce=o("p"),xr=s(`The authors originally required the user to manually provide the source and target prompts for discovering
edit directions. However, we can also leverage open source and public models for the same purpose.
Below, we provide an end-to-end example with the `),Je=o("a"),Pr=s("Flan-T5"),Ir=s(` model
for generating source an target embeddings.`),Di=p(),Ye=o("p"),ro=o("strong"),Sr=s("1. Load the generation model"),jr=s(":"),$i=p(),m(Qe.$$.fragment),xi=p(),et=o("p"),lo=o("strong"),Tr=s("2. Construct a starting prompt"),qr=s(":"),Pi=p(),m(tt.$$.fragment),Ii=p(),Kt=o("p"),Lr=s("Here, we\u2019re interested in the \u201Cbowl -> basket\u201D direction."),Si=p(),nt=o("p"),po=o("strong"),Cr=s("3. Generate prompts"),Ar=s(":"),ji=p(),Zt=o("p"),Nr=s("We can use a utility like so for this purpose."),Ti=p(),m(ot.$$.fragment),qi=p(),Jt=o("p"),Mr=s("And then we just call it to generate our prompts:"),Li=p(),m(it.$$.fragment),Ci=p(),A=o("p"),Or=s(`We encourage you to play around with the different parameters supported by the
`),fo=o("code"),Gr=s("generate()"),zr=s(" method ("),at=o("a"),Fr=s("documentation"),Br=s(") for the generation quality you are looking for."),Ai=p(),st=o("p"),co=o("strong"),Ur=s("4. Load the embedding model"),Rr=s(":"),Ni=p(),Yt=o("p"),Vr=s("Here, we need to use the same text encoder model used by the subsequent Stable Diffusion model."),Mi=p(),m(rt.$$.fragment),Oi=p(),lt=o("p"),mo=o("strong"),Hr=s("5. Compute embeddings"),Wr=s(":"),Gi=p(),m(pt.$$.fragment),zi=p(),Qt=o("p"),Xr=s("And you\u2019re done! Now, you can use these embeddings directly while calling the pipeline:"),Fi=p(),m(dt.$$.fragment),Bi=p(),Y=o("h2"),me=o("a"),go=o("span"),m(ft.$$.fragment),Kr=p(),uo=o("span"),Zr=s("StableDiffusionDiffEditPipeline"),Ui=p(),b=o("div"),m(ct.$$.fragment),Jr=p(),mt=o("p"),Yr=s("Pipeline for text-guided image inpainting using Stable Diffusion using DiffEdit. "),ho=o("em"),Qr=s("This is an experimental feature"),el=s("."),tl=p(),gt=o("p"),nl=s("This model inherits from "),en=o("a"),ol=s("DiffusionPipeline"),il=s(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),al=p(),_o=o("p"),sl=s("In addition the pipeline inherits the following loading methods:"),rl=p(),ut=o("ul"),ht=o("li"),vo=o("em"),ll=s("Textual-Inversion"),pl=s(": "),tn=o("a"),dl=s("loaders.TextualInversionLoaderMixin.load_textual_inversion()"),fl=p(),_t=o("li"),bo=o("em"),cl=s("LoRA"),ml=s(": "),nn=o("a"),gl=s("loaders.LoraLoaderMixin.load_lora_weights()"),ul=p(),wo=o("p"),hl=s("as well as the following saving methods:"),_l=p(),yo=o("ul"),vt=o("li"),Eo=o("em"),vl=s("LoRA"),bl=s(": "),on=o("a"),wl=s("loaders.LoraLoaderMixin.save_lora_weights()"),yl=p(),N=o("div"),m(bt.$$.fragment),El=p(),ko=o("p"),kl=s("Function used to generate a latent mask given a mask prompt, a target prompt, and an image."),Dl=p(),Do=o("p"),$l=s("Examples:"),xl=p(),M=o("div"),m(wt.$$.fragment),Pl=p(),$o=o("p"),Il=s("Function used to generate inverted latents given a prompt and image."),Sl=p(),m(ge.$$.fragment),jl=p(),ue=o("div"),m(yt.$$.fragment),Tl=p(),Et=o("p"),ql=s("Disable sliced VAE decoding. If "),xo=o("code"),Ll=s("enable_vae_slicing"),Cl=s(` was previously invoked, this method will go back to
computing decoding in one step.`),Al=p(),he=o("div"),m(kt.$$.fragment),Nl=p(),Dt=o("p"),Ml=s("Disable tiled VAE decoding. If "),Po=o("code"),Ol=s("enable_vae_tiling"),Gl=s(` was previously invoked, this method will go back to
computing decoding in one step.`),zl=p(),_e=o("div"),m($t.$$.fragment),Fl=p(),I=o("p"),Bl=s(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Io=o("code"),Ul=s("enable_sequential_cpu_offload"),Rl=s(", this method moves one whole model at a time to the GPU when its "),So=o("code"),Vl=s("forward"),Hl=s(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),jo=o("code"),Wl=s("enable_sequential_cpu_offload"),Xl=s(", but performance is much better due to the iterative execution of the "),To=o("code"),Kl=s("unet"),Zl=s("."),Jl=p(),ve=o("div"),m(xt.$$.fragment),Yl=p(),Q=o("p"),Ql=s(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),qo=o("code"),ep=s("torch.device('meta') and loaded to GPU only when their specific submodule has its "),tp=s("forward"),Lo=o("code"),np=s("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),op=s("enable_model_cpu_offload`, but performance is lower."),ip=p(),O=o("div"),m(Pt.$$.fragment),ap=p(),Co=o("p"),sp=s("Enable sliced VAE decoding."),rp=p(),Ao=o("p"),lp=s(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),pp=p(),G=o("div"),m(It.$$.fragment),dp=p(),No=o("p"),fp=s("Enable tiled VAE decoding."),cp=p(),Mo=o("p"),mp=s(`When this option is enabled, the VAE will split the input tensor into tiles to compute decoding and encoding in
several steps. This is useful to save a large amount of memory and to allow the processing of larger images.`),Ri=p(),an=o("ul"),Oo=o("li"),Go=o("strong"),gp=s("call"),this.h()},l(e){const l=Ff('[data-svelte="svelte-1phssyn"]',document.head);D=i(l,"META",{name:!0,content:!0}),l.forEach(n),B=d(e),y=i(e,"H1",{class:!0});var St=a(y);L=i(St,"A",{id:!0,class:!0,href:!0});var $p=a(L);un=i($p,"SPAN",{});var xp=a(un);g(Ee.$$.fragment,xp),xp.forEach(n),$p.forEach(n),wa=d(St),hn=i(St,"SPAN",{});var Pp=a(hn);ya=r(Pp,"Zero-shot Diffusion-based Semantic Image Editing with Mask Guidance"),Pp.forEach(n),St.forEach(n),Fo=d(e),U=i(e,"H2",{class:!0});var Hi=a(U);ne=i(Hi,"A",{id:!0,class:!0,href:!0});var Ip=a(ne);_n=i(Ip,"SPAN",{});var Sp=a(_n);g(ke.$$.fragment,Sp),Sp.forEach(n),Ip.forEach(n),Ea=d(Hi),vn=i(Hi,"SPAN",{});var jp=a(vn);ka=r(jp,"Overview"),jp.forEach(n),Hi.forEach(n),Bo=d(e),De=i(e,"P",{});var up=a(De);$e=i(up,"A",{href:!0,rel:!0});var Tp=a($e);Da=r(Tp,"DiffEdit: Diffusion-based semantic image editing with mask guidance"),Tp.forEach(n),$a=r(up," by Guillaume Couairon, Jakob Verbeek, Holger Schwenk, and Matthieu Cord."),up.forEach(n),Uo=d(e),jt=i(e,"P",{});var qp=a(jt);xa=r(qp,"The abstract of the paper is the following:"),qp.forEach(n),Ro=d(e),Tt=i(e,"P",{});var Lp=a(Tt);bn=i(Lp,"EM",{});var Cp=a(bn);Pa=r(Cp,"Image generation has recently seen tremendous advances, with diffusion models allowing to synthesize convincing images for a large variety of text prompts. In this article, we propose DiffEdit, a method to take advantage of text-conditioned diffusion models for the task of semantic image editing, where the goal is to edit an image based on a text query. Semantic image editing is an extension of image generation, with the additional constraint that the generated image should be as similar as possible to a given input image. Current editing methods based on diffusion models usually require to provide a mask, making the task much easier by treating it as a conditional inpainting task. In contrast, our main contribution is able to automatically generate a mask highlighting regions of the input image that need to be edited, by contrasting predictions of a diffusion model conditioned on different text prompts. Moreover, we rely on latent inference to preserve content in those regions of interest and show excellent synergies with mask-based diffusion. DiffEdit achieves state-of-the-art editing performance on ImageNet. In addition, we evaluate semantic image editing in more challenging settings, using images from the COCO dataset as well as text-based generated images."),Cp.forEach(n),Lp.forEach(n),Vo=d(e),qt=i(e,"P",{});var Ap=a(qt);Ia=r(Ap,"Resources:"),Ap.forEach(n),Ho=d(e),C=i(e,"UL",{});var sn=a(C);Lt=i(sn,"LI",{});var hp=a(Lt);xe=i(hp,"A",{href:!0,rel:!0});var Np=a(xe);Sa=r(Np,"Paper"),Np.forEach(n),ja=r(hp,"."),hp.forEach(n),Ta=d(sn),Ct=i(sn,"LI",{});var _p=a(Ct);Pe=i(_p,"A",{href:!0,rel:!0});var Mp=a(Pe);qa=r(Mp,"Blog Post with Demo"),Mp.forEach(n),La=r(_p,"."),_p.forEach(n),Ca=d(sn),At=i(sn,"LI",{});var vp=a(At);Ie=i(vp,"A",{href:!0,rel:!0});var Op=a(Ie);Aa=r(Op,"Implementation on Github"),Op.forEach(n),Na=r(vp,"."),vp.forEach(n),sn.forEach(n),Wo=d(e),R=i(e,"H2",{class:!0});var Wi=a(R);oe=i(Wi,"A",{id:!0,class:!0,href:!0});var Gp=a(oe);wn=i(Gp,"SPAN",{});var zp=a(wn);g(Se.$$.fragment,zp),zp.forEach(n),Gp.forEach(n),Ma=d(Wi),yn=i(Wi,"SPAN",{});var Fp=a(yn);Oa=r(Fp,"Tips"),Fp.forEach(n),Wi.forEach(n),Xo=d(e),E=i(e,"UL",{});var x=a(E);En=i(x,"LI",{});var Bp=a(En);Ga=r(Bp,"The pipeline can generate masks that can be fed into other inpainting pipelines. Check out the code examples below to know more."),Bp.forEach(n),za=d(x),j=i(x,"LI",{});var be=a(j);Fa=r(be,"In order to generate an image using this pipeline, both an image mask (manually specified or generated using "),kn=i(be,"CODE",{});var Up=a(kn);Ba=r(Up,"generate_mask"),Up.forEach(n),Ua=r(be,`)
and a set of partially inverted latents (generated using `),Dn=i(be,"CODE",{});var Rp=a(Dn);Ra=r(Rp,"invert"),Rp.forEach(n),Va=r(be,") "),$n=i(be,"EM",{});var Vp=a($n);Ha=r(Vp,"must"),Vp.forEach(n),Wa=r(be,` be provided as arguments when calling the pipeline to generate the final edited image.
Refer to the code examples below for more details.`),be.forEach(n),Xa=d(x),$=i(x,"LI",{});var S=a($);Ka=r(S,"The function "),xn=i(S,"CODE",{});var Hp=a(xn);Za=r(Hp,"generate_mask"),Hp.forEach(n),Ja=r(S," exposes two prompt arguments, "),Pn=i(S,"CODE",{});var Wp=a(Pn);Ya=r(Wp,"source_prompt"),Wp.forEach(n),Qa=r(S," and "),In=i(S,"CODE",{});var Xp=a(In);es=r(Xp,"target_prompt"),Xp.forEach(n),ts=r(S,`,
that let you control the locations of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the generated mask, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Sn=i(S,"CODE",{});var Kp=a(Sn);ns=r(Kp,"source_prompt_embeds"),Kp.forEach(n),os=r(S," and \u201Cdog\u201D to "),jn=i(S,"CODE",{});var Zp=a(jn);is=r(Zp,"target_prompt_embeds"),Zp.forEach(n),as=r(S,". Refer to the code example below for more details."),S.forEach(n),ss=d(x),T=i(x,"LI",{});var we=a(T);rs=r(we,"When generating partially inverted latents using "),Tn=i(we,"CODE",{});var Jp=a(Tn);ls=r(Jp,"invert"),Jp.forEach(n),ps=r(we,`, assign a caption or text embedding describing the
overall image to the `),qn=i(we,"CODE",{});var Yp=a(qn);ds=r(Yp,"prompt"),Yp.forEach(n),fs=r(we,` argument to help guide the inverse latent sampling process. In most cases, the
source concept is sufficently descriptive to yield good results, but feel free to explore alternatives.
Please refer to `),Nt=i(we,"A",{href:!0});var Qp=a(Nt);cs=r(Qp,"this code example"),Qp.forEach(n),ms=r(we," for more details."),we.forEach(n),gs=d(x),P=i(x,"LI",{});var z=a(P);us=r(z,"When calling the pipeline to generate the final edited image, assign the source concept to "),Ln=i(z,"CODE",{});var ed=a(Ln);hs=r(ed,"negative_prompt"),ed.forEach(n),_s=r(z,`
and the target concept to `),Cn=i(z,"CODE",{});var td=a(Cn);vs=r(td,"prompt"),td.forEach(n),bs=r(z,`. Taking the above example, you simply have to set the embeddings related to
the phrases including \u201Ccat\u201D to `),An=i(z,"CODE",{});var nd=a(An);ws=r(nd,"negative_prompt_embeds"),nd.forEach(n),ys=r(z," and \u201Cdog\u201D to "),Nn=i(z,"CODE",{});var od=a(Nn);Es=r(od,"prompt_embeds"),od.forEach(n),ks=r(z,`. Refer to the code example
below for more details.`),z.forEach(n),Ds=d(x),Mt=i(x,"LI",{});var bp=a(Mt);$s=r(bp,"If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),V=i(bp,"UL",{});var rn=a(V);q=i(rn,"LI",{});var ye=a(q);xs=r(ye,"Swap the "),Mn=i(ye,"CODE",{});var id=a(Mn);Ps=r(id,"source_prompt"),id.forEach(n),Is=r(ye," and "),On=i(ye,"CODE",{});var ad=a(On);Ss=r(ad,"target_prompt"),ad.forEach(n),js=r(ye," in the arguments to "),Gn=i(ye,"CODE",{});var sd=a(Gn);Ts=r(sd,"generate_mask"),sd.forEach(n),qs=r(ye,"."),ye.forEach(n),Ls=d(rn),je=i(rn,"LI",{});var Xi=a(je);Cs=r(Xi,"Change the input prompt for "),zn=i(Xi,"CODE",{});var rd=a(zn);As=r(rd,"invert"),rd.forEach(n),Ns=r(Xi," to include \u201Cdog\u201D."),Xi.forEach(n),Ms=d(rn),H=i(rn,"LI",{});var ln=a(H);Os=r(ln,"Swap the "),Fn=i(ln,"CODE",{});var ld=a(Fn);Gs=r(ld,"prompt"),ld.forEach(n),zs=r(ln," and "),Bn=i(ln,"CODE",{});var pd=a(Bn);Fs=r(pd,"negative_prompt"),pd.forEach(n),Bs=r(ln," in the arguments to call the pipeline to generate the final edited image."),ln.forEach(n),rn.forEach(n),bp.forEach(n),Us=d(x),Te=i(x,"LI",{});var Ki=a(Te);Rs=r(Ki,"Note that the source and target prompts, or their corresponding embeddings, can also be automatically generated. Please, refer to "),Ot=i(Ki,"A",{href:!0});var dd=a(Ot);Vs=r(dd,"this discussion"),dd.forEach(n),Hs=r(Ki," for more details."),Ki.forEach(n),x.forEach(n),Ko=d(e),W=i(e,"H2",{class:!0});var Zi=a(W);ie=i(Zi,"A",{id:!0,class:!0,href:!0});var fd=a(ie);Un=i(fd,"SPAN",{});var cd=a(Un);g(qe.$$.fragment,cd),cd.forEach(n),fd.forEach(n),Ws=d(Zi),Rn=i(Zi,"SPAN",{});var md=a(Rn);Xs=r(md,"Available Pipelines:"),md.forEach(n),Zi.forEach(n),Zo=d(e),ae=i(e,"TABLE",{});var Ji=a(ae);Vn=i(Ji,"THEAD",{});var gd=a(Vn);Le=i(gd,"TR",{});var Yi=a(Le);Hn=i(Yi,"TH",{});var ud=a(Hn);Ks=r(ud,"Pipeline"),ud.forEach(n),Zs=d(Yi),Wn=i(Yi,"TH",{});var hd=a(Wn);Js=r(hd,"Tasks"),hd.forEach(n),Yi.forEach(n),gd.forEach(n),Ys=d(Ji),Xn=i(Ji,"TBODY",{});var _d=a(Xn);Ce=i(_d,"TR",{});var Qi=a(Ce);Kn=i(Qi,"TD",{});var vd=a(Kn);Ae=i(vd,"A",{href:!0,rel:!0});var bd=a(Ae);Qs=r(bd,"StableDiffusionDiffEditPipeline"),bd.forEach(n),vd.forEach(n),er=d(Qi),Zn=i(Qi,"TD",{});var wd=a(Zn);Jn=i(wd,"EM",{});var yd=a(Jn);tr=r(yd,"Text-Based Image Editing"),yd.forEach(n),wd.forEach(n),Qi.forEach(n),_d.forEach(n),Ji.forEach(n),Jo=d(e),X=i(e,"H2",{class:!0});var ea=a(X);se=i(ea,"A",{id:!0,class:!0,href:!0});var Ed=a(se);Yn=i(Ed,"SPAN",{});var kd=a(Yn);g(Ne.$$.fragment,kd),kd.forEach(n),Ed.forEach(n),nr=d(ea),Qn=i(ea,"SPAN",{});var Dd=a(Qn);or=r(Dd,"Usage example"),Dd.forEach(n),ea.forEach(n),Yo=d(e),K=i(e,"H3",{class:!0});var ta=a(K);re=i(ta,"A",{id:!0,class:!0,href:!0});var $d=a(re);eo=i($d,"SPAN",{});var xd=a(eo);g(Me.$$.fragment,xd),xd.forEach(n),$d.forEach(n),ir=d(ta),to=i(ta,"SPAN",{});var Pd=a(to);ar=r(Pd,"Based on an input image with a caption"),Pd.forEach(n),ta.forEach(n),Qo=d(e),le=i(e,"P",{});var na=a(le);sr=r(na,`When the pipeline is conditioned on an input image, we first obtain partially inverted latents from the input image using a
`),no=i(na,"CODE",{});var Id=a(no);rr=r(Id,"DDIMInverseScheduler"),Id.forEach(n),lr=r(na,` with the help of a caption. Then we generate an editing mask to identify relevant regions in the image using the source and target prompts. Finally,
the inverted noise and generated mask is used to start the generation process.`),na.forEach(n),ei=d(e),Gt=i(e,"P",{});var Sd=a(Gt);pr=r(Sd,"First, let\u2019s load our pipeline:"),Sd.forEach(n),ti=d(e),g(Oe.$$.fragment,e),ni=d(e),zt=i(e,"P",{});var jd=a(zt);dr=r(jd,"Then, we load an input image to edit using our method:"),jd.forEach(n),oi=d(e),g(Ge.$$.fragment,e),ii=d(e),Ft=i(e,"P",{});var Td=a(Ft);fr=r(Td,"Then, we employ the source and target prompts to generate the editing mask:"),Td.forEach(n),ai=d(e),g(ze.$$.fragment,e),si=d(e),Bt=i(e,"P",{});var qd=a(Bt);cr=r(qd,"Then, we employ the caption and the input image to get the inverted latents:"),qd.forEach(n),ri=d(e),g(Fe.$$.fragment,e),li=d(e),Ut=i(e,"P",{});var Ld=a(Ut);mr=r(Ld,"Now, generate the image with the inverted latents and semantically generated mask:"),Ld.forEach(n),pi=d(e),g(Be.$$.fragment,e),di=d(e),Z=i(e,"H2",{class:!0});var oa=a(Z);pe=i(oa,"A",{id:!0,class:!0,href:!0});var Cd=a(pe);oo=i(Cd,"SPAN",{});var Ad=a(oo);g(Ue.$$.fragment,Ad),Ad.forEach(n),Cd.forEach(n),gr=d(oa),io=i(oa,"SPAN",{});var Nd=a(io);ur=r(Nd,"Generating image captions for inversion"),Nd.forEach(n),oa.forEach(n),fi=d(e),de=i(e,"P",{});var ia=a(de);hr=r(ia,`The authors originally used the source concept prompt as the caption for generating the partially inverted latents. However, we can also leverage open source and public image captioning models for the same purpose.
Below, we provide an end-to-end example with the `),Re=i(ia,"A",{href:!0,rel:!0});var Md=a(Re);_r=r(Md,"BLIP"),Md.forEach(n),vr=r(ia,` model
for generating captions.`),ia.forEach(n),ci=d(e),Rt=i(e,"P",{});var Od=a(Rt);br=r(Od,"First, let\u2019s load our automatic image captioning model:"),Od.forEach(n),mi=d(e),g(Ve.$$.fragment,e),gi=d(e),Vt=i(e,"P",{});var Gd=a(Vt);wr=r(Gd,"Then, we define a utility to generate captions from an input image using the model:"),Gd.forEach(n),ui=d(e),g(He.$$.fragment,e),hi=d(e),Ht=i(e,"P",{});var zd=a(Ht);yr=r(zd,"Then, we load an input image for conditioning and obtain a suitable caption for it:"),zd.forEach(n),_i=d(e),g(We.$$.fragment,e),vi=d(e),Wt=i(e,"P",{});var Fd=a(Wt);Er=r(Fd,"Then, we employ the generated caption and the input image to get the inverted latents:"),Fd.forEach(n),bi=d(e),g(Xe.$$.fragment,e),wi=d(e),Xt=i(e,"P",{});var Bd=a(Xt);kr=r(Bd,"Now, generate the image with the inverted latents and semantically generated mask from our source and target prompts:"),Bd.forEach(n),yi=d(e),g(Ke.$$.fragment,e),Ei=d(e),J=i(e,"H2",{class:!0});var aa=a(J);fe=i(aa,"A",{id:!0,class:!0,href:!0});var Ud=a(fe);ao=i(Ud,"SPAN",{});var Rd=a(ao);g(Ze.$$.fragment,Rd),Rd.forEach(n),Ud.forEach(n),Dr=d(aa),so=i(aa,"SPAN",{});var Vd=a(so);$r=r(Vd,"Generating source and target embeddings"),Vd.forEach(n),aa.forEach(n),ki=d(e),ce=i(e,"P",{});var sa=a(ce);xr=r(sa,`The authors originally required the user to manually provide the source and target prompts for discovering
edit directions. However, we can also leverage open source and public models for the same purpose.
Below, we provide an end-to-end example with the `),Je=i(sa,"A",{href:!0,rel:!0});var Hd=a(Je);Pr=r(Hd,"Flan-T5"),Hd.forEach(n),Ir=r(sa,` model
for generating source an target embeddings.`),sa.forEach(n),Di=d(e),Ye=i(e,"P",{});var wp=a(Ye);ro=i(wp,"STRONG",{});var Wd=a(ro);Sr=r(Wd,"1. Load the generation model"),Wd.forEach(n),jr=r(wp,":"),wp.forEach(n),$i=d(e),g(Qe.$$.fragment,e),xi=d(e),et=i(e,"P",{});var yp=a(et);lo=i(yp,"STRONG",{});var Xd=a(lo);Tr=r(Xd,"2. Construct a starting prompt"),Xd.forEach(n),qr=r(yp,":"),yp.forEach(n),Pi=d(e),g(tt.$$.fragment,e),Ii=d(e),Kt=i(e,"P",{});var Kd=a(Kt);Lr=r(Kd,"Here, we\u2019re interested in the \u201Cbowl -> basket\u201D direction."),Kd.forEach(n),Si=d(e),nt=i(e,"P",{});var Ep=a(nt);po=i(Ep,"STRONG",{});var Zd=a(po);Cr=r(Zd,"3. Generate prompts"),Zd.forEach(n),Ar=r(Ep,":"),Ep.forEach(n),ji=d(e),Zt=i(e,"P",{});var Jd=a(Zt);Nr=r(Jd,"We can use a utility like so for this purpose."),Jd.forEach(n),Ti=d(e),g(ot.$$.fragment,e),qi=d(e),Jt=i(e,"P",{});var Yd=a(Jt);Mr=r(Yd,"And then we just call it to generate our prompts:"),Yd.forEach(n),Li=d(e),g(it.$$.fragment,e),Ci=d(e),A=i(e,"P",{});var pn=a(A);Or=r(pn,`We encourage you to play around with the different parameters supported by the
`),fo=i(pn,"CODE",{});var Qd=a(fo);Gr=r(Qd,"generate()"),Qd.forEach(n),zr=r(pn," method ("),at=i(pn,"A",{href:!0,rel:!0});var ef=a(at);Fr=r(ef,"documentation"),ef.forEach(n),Br=r(pn,") for the generation quality you are looking for."),pn.forEach(n),Ai=d(e),st=i(e,"P",{});var kp=a(st);co=i(kp,"STRONG",{});var tf=a(co);Ur=r(tf,"4. Load the embedding model"),tf.forEach(n),Rr=r(kp,":"),kp.forEach(n),Ni=d(e),Yt=i(e,"P",{});var nf=a(Yt);Vr=r(nf,"Here, we need to use the same text encoder model used by the subsequent Stable Diffusion model."),nf.forEach(n),Mi=d(e),g(rt.$$.fragment,e),Oi=d(e),lt=i(e,"P",{});var Dp=a(lt);mo=i(Dp,"STRONG",{});var of=a(mo);Hr=r(of,"5. Compute embeddings"),of.forEach(n),Wr=r(Dp,":"),Dp.forEach(n),Gi=d(e),g(pt.$$.fragment,e),zi=d(e),Qt=i(e,"P",{});var af=a(Qt);Xr=r(af,"And you\u2019re done! Now, you can use these embeddings directly while calling the pipeline:"),af.forEach(n),Fi=d(e),g(dt.$$.fragment,e),Bi=d(e),Y=i(e,"H2",{class:!0});var ra=a(Y);me=i(ra,"A",{id:!0,class:!0,href:!0});var sf=a(me);go=i(sf,"SPAN",{});var rf=a(go);g(ft.$$.fragment,rf),rf.forEach(n),sf.forEach(n),Kr=d(ra),uo=i(ra,"SPAN",{});var lf=a(uo);Zr=r(lf,"StableDiffusionDiffEditPipeline"),lf.forEach(n),ra.forEach(n),Ui=d(e),b=i(e,"DIV",{class:!0});var w=a(b);g(ct.$$.fragment,w),Jr=d(w),mt=i(w,"P",{});var la=a(mt);Yr=r(la,"Pipeline for text-guided image inpainting using Stable Diffusion using DiffEdit. "),ho=i(la,"EM",{});var pf=a(ho);Qr=r(pf,"This is an experimental feature"),pf.forEach(n),el=r(la,"."),la.forEach(n),tl=d(w),gt=i(w,"P",{});var pa=a(gt);nl=r(pa,"This model inherits from "),en=i(pa,"A",{href:!0});var df=a(en);ol=r(df,"DiffusionPipeline"),df.forEach(n),il=r(pa,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),pa.forEach(n),al=d(w),_o=i(w,"P",{});var ff=a(_o);sl=r(ff,"In addition the pipeline inherits the following loading methods:"),ff.forEach(n),rl=d(w),ut=i(w,"UL",{});var da=a(ut);ht=i(da,"LI",{});var fa=a(ht);vo=i(fa,"EM",{});var cf=a(vo);ll=r(cf,"Textual-Inversion"),cf.forEach(n),pl=r(fa,": "),tn=i(fa,"A",{href:!0});var mf=a(tn);dl=r(mf,"loaders.TextualInversionLoaderMixin.load_textual_inversion()"),mf.forEach(n),fa.forEach(n),fl=d(da),_t=i(da,"LI",{});var ca=a(_t);bo=i(ca,"EM",{});var gf=a(bo);cl=r(gf,"LoRA"),gf.forEach(n),ml=r(ca,": "),nn=i(ca,"A",{href:!0});var uf=a(nn);gl=r(uf,"loaders.LoraLoaderMixin.load_lora_weights()"),uf.forEach(n),ca.forEach(n),da.forEach(n),ul=d(w),wo=i(w,"P",{});var hf=a(wo);hl=r(hf,"as well as the following saving methods:"),hf.forEach(n),_l=d(w),yo=i(w,"UL",{});var _f=a(yo);vt=i(_f,"LI",{});var ma=a(vt);Eo=i(ma,"EM",{});var vf=a(Eo);vl=r(vf,"LoRA"),vf.forEach(n),bl=r(ma,": "),on=i(ma,"A",{href:!0});var bf=a(on);wl=r(bf,"loaders.LoraLoaderMixin.save_lora_weights()"),bf.forEach(n),ma.forEach(n),_f.forEach(n),yl=d(w),N=i(w,"DIV",{class:!0});var dn=a(N);g(bt.$$.fragment,dn),El=d(dn),ko=i(dn,"P",{});var wf=a(ko);kl=r(wf,"Function used to generate a latent mask given a mask prompt, a target prompt, and an image."),wf.forEach(n),Dl=d(dn),Do=i(dn,"P",{});var yf=a(Do);$l=r(yf,"Examples:"),yf.forEach(n),dn.forEach(n),xl=d(w),M=i(w,"DIV",{class:!0});var fn=a(M);g(wt.$$.fragment,fn),Pl=d(fn),$o=i(fn,"P",{});var Ef=a($o);Il=r(Ef,"Function used to generate inverted latents given a prompt and image."),Ef.forEach(n),Sl=d(fn),g(ge.$$.fragment,fn),fn.forEach(n),jl=d(w),ue=i(w,"DIV",{class:!0});var ga=a(ue);g(yt.$$.fragment,ga),Tl=d(ga),Et=i(ga,"P",{});var ua=a(Et);ql=r(ua,"Disable sliced VAE decoding. If "),xo=i(ua,"CODE",{});var kf=a(xo);Ll=r(kf,"enable_vae_slicing"),kf.forEach(n),Cl=r(ua,` was previously invoked, this method will go back to
computing decoding in one step.`),ua.forEach(n),ga.forEach(n),Al=d(w),he=i(w,"DIV",{class:!0});var ha=a(he);g(kt.$$.fragment,ha),Nl=d(ha),Dt=i(ha,"P",{});var _a=a(Dt);Ml=r(_a,"Disable tiled VAE decoding. If "),Po=i(_a,"CODE",{});var Df=a(Po);Ol=r(Df,"enable_vae_tiling"),Df.forEach(n),Gl=r(_a,` was previously invoked, this method will go back to
computing decoding in one step.`),_a.forEach(n),ha.forEach(n),zl=d(w),_e=i(w,"DIV",{class:!0});var va=a(_e);g($t.$$.fragment,va),Fl=d(va),I=i(va,"P",{});var F=a(I);Bl=r(F,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Io=i(F,"CODE",{});var $f=a(Io);Ul=r($f,"enable_sequential_cpu_offload"),$f.forEach(n),Rl=r(F,", this method moves one whole model at a time to the GPU when its "),So=i(F,"CODE",{});var xf=a(So);Vl=r(xf,"forward"),xf.forEach(n),Hl=r(F,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),jo=i(F,"CODE",{});var Pf=a(jo);Wl=r(Pf,"enable_sequential_cpu_offload"),Pf.forEach(n),Xl=r(F,", but performance is much better due to the iterative execution of the "),To=i(F,"CODE",{});var If=a(To);Kl=r(If,"unet"),If.forEach(n),Zl=r(F,"."),F.forEach(n),va.forEach(n),Jl=d(w),ve=i(w,"DIV",{class:!0});var ba=a(ve);g(xt.$$.fragment,ba),Yl=d(ba),Q=i(ba,"P",{});var cn=a(Q);Ql=r(cn,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),qo=i(cn,"CODE",{});var Sf=a(qo);ep=r(Sf,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Sf.forEach(n),tp=r(cn,"forward"),Lo=i(cn,"CODE",{});var jf=a(Lo);np=r(jf,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),jf.forEach(n),op=r(cn,"enable_model_cpu_offload`, but performance is lower."),cn.forEach(n),ba.forEach(n),ip=d(w),O=i(w,"DIV",{class:!0});var mn=a(O);g(Pt.$$.fragment,mn),ap=d(mn),Co=i(mn,"P",{});var Tf=a(Co);sp=r(Tf,"Enable sliced VAE decoding."),Tf.forEach(n),rp=d(mn),Ao=i(mn,"P",{});var qf=a(Ao);lp=r(qf,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),qf.forEach(n),mn.forEach(n),pp=d(w),G=i(w,"DIV",{class:!0});var gn=a(G);g(It.$$.fragment,gn),dp=d(gn),No=i(gn,"P",{});var Lf=a(No);fp=r(Lf,"Enable tiled VAE decoding."),Lf.forEach(n),cp=d(gn),Mo=i(gn,"P",{});var Cf=a(Mo);mp=r(Cf,`When this option is enabled, the VAE will split the input tensor into tiles to compute decoding and encoding in
several steps. This is useful to save a large amount of memory and to allow the processing of larger images.`),Cf.forEach(n),gn.forEach(n),w.forEach(n),Ri=d(e),an=i(e,"UL",{});var Af=a(an);Oo=i(Af,"LI",{});var Nf=a(Oo);Go=i(Nf,"STRONG",{});var Mf=a(Go);gp=r(Mf,"call"),Mf.forEach(n),Nf.forEach(n),Af.forEach(n),this.h()},h(){c(D,"name","hf:doc:metadata"),c(D,"content",JSON.stringify(Wf)),c(L,"id","zeroshot-diffusionbased-semantic-image-editing-with-mask-guidance"),c(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(L,"href","#zeroshot-diffusionbased-semantic-image-editing-with-mask-guidance"),c(y,"class","relative group"),c(ne,"id","overview"),c(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ne,"href","#overview"),c(U,"class","relative group"),c($e,"href","https://arxiv.org/abs/2210.11427"),c($e,"rel","nofollow"),c(xe,"href","https://arxiv.org/abs/2210.11427"),c(xe,"rel","nofollow"),c(Pe,"href","https://blog.problemsolversguild.com/technical/research/2022/11/02/DiffEdit-Implementation.html"),c(Pe,"rel","nofollow"),c(Ie,"href","https://github.com/Xiang-cd/DiffEdit-stable-diffusion/"),c(Ie,"rel","nofollow"),c(oe,"id","tips"),c(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(oe,"href","#tips"),c(R,"class","relative group"),c(Nt,"href","#generating-image-captions-for-inversion"),c(Ot,"href","#generating-source-and-target-embeddings"),c(ie,"id","available-pipelines"),c(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ie,"href","#available-pipelines"),c(W,"class","relative group"),c(Ae,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_diffedit.py"),c(Ae,"rel","nofollow"),c(se,"id","usage-example"),c(se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(se,"href","#usage-example"),c(X,"class","relative group"),c(re,"id","based-on-an-input-image-with-a-caption"),c(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(re,"href","#based-on-an-input-image-with-a-caption"),c(K,"class","relative group"),c(pe,"id","generating-image-captions-for-inversion"),c(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(pe,"href","#generating-image-captions-for-inversion"),c(Z,"class","relative group"),c(Re,"href","https://huggingface.co/docs/transformers/model_doc/blip"),c(Re,"rel","nofollow"),c(fe,"id","generating-source-and-target-embeddings"),c(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(fe,"href","#generating-source-and-target-embeddings"),c(J,"class","relative group"),c(Je,"href","https://huggingface.co/docs/transformers/model_doc/flan-t5"),c(Je,"rel","nofollow"),c(at,"href","https://huggingface.co/docs/transformers/main/en/main_classes/text_generation#transformers.generation_tf_utils.TFGenerationMixin.generate"),c(at,"rel","nofollow"),c(me,"id","diffusers.StableDiffusionDiffEditPipeline"),c(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(me,"href","#diffusers.StableDiffusionDiffEditPipeline"),c(Y,"class","relative group"),c(en,"href","/docs/diffusers/pr_2352/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(tn,"href","/docs/diffusers/pr_2352/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline.load_textual_inversion"),c(nn,"href","/docs/diffusers/pr_2352/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.load_lora_weights"),c(on,"href","/docs/diffusers/pr_2352/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.save_lora_weights"),c(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,l){t(document.head,D),f(e,B,l),f(e,y,l),t(y,L),t(L,un),u(Ee,un,null),t(y,wa),t(y,hn),t(hn,ya),f(e,Fo,l),f(e,U,l),t(U,ne),t(ne,_n),u(ke,_n,null),t(U,Ea),t(U,vn),t(vn,ka),f(e,Bo,l),f(e,De,l),t(De,$e),t($e,Da),t(De,$a),f(e,Uo,l),f(e,jt,l),t(jt,xa),f(e,Ro,l),f(e,Tt,l),t(Tt,bn),t(bn,Pa),f(e,Vo,l),f(e,qt,l),t(qt,Ia),f(e,Ho,l),f(e,C,l),t(C,Lt),t(Lt,xe),t(xe,Sa),t(Lt,ja),t(C,Ta),t(C,Ct),t(Ct,Pe),t(Pe,qa),t(Ct,La),t(C,Ca),t(C,At),t(At,Ie),t(Ie,Aa),t(At,Na),f(e,Wo,l),f(e,R,l),t(R,oe),t(oe,wn),u(Se,wn,null),t(R,Ma),t(R,yn),t(yn,Oa),f(e,Xo,l),f(e,E,l),t(E,En),t(En,Ga),t(E,za),t(E,j),t(j,Fa),t(j,kn),t(kn,Ba),t(j,Ua),t(j,Dn),t(Dn,Ra),t(j,Va),t(j,$n),t($n,Ha),t(j,Wa),t(E,Xa),t(E,$),t($,Ka),t($,xn),t(xn,Za),t($,Ja),t($,Pn),t(Pn,Ya),t($,Qa),t($,In),t(In,es),t($,ts),t($,Sn),t(Sn,ns),t($,os),t($,jn),t(jn,is),t($,as),t(E,ss),t(E,T),t(T,rs),t(T,Tn),t(Tn,ls),t(T,ps),t(T,qn),t(qn,ds),t(T,fs),t(T,Nt),t(Nt,cs),t(T,ms),t(E,gs),t(E,P),t(P,us),t(P,Ln),t(Ln,hs),t(P,_s),t(P,Cn),t(Cn,vs),t(P,bs),t(P,An),t(An,ws),t(P,ys),t(P,Nn),t(Nn,Es),t(P,ks),t(E,Ds),t(E,Mt),t(Mt,$s),t(Mt,V),t(V,q),t(q,xs),t(q,Mn),t(Mn,Ps),t(q,Is),t(q,On),t(On,Ss),t(q,js),t(q,Gn),t(Gn,Ts),t(q,qs),t(V,Ls),t(V,je),t(je,Cs),t(je,zn),t(zn,As),t(je,Ns),t(V,Ms),t(V,H),t(H,Os),t(H,Fn),t(Fn,Gs),t(H,zs),t(H,Bn),t(Bn,Fs),t(H,Bs),t(E,Us),t(E,Te),t(Te,Rs),t(Te,Ot),t(Ot,Vs),t(Te,Hs),f(e,Ko,l),f(e,W,l),t(W,ie),t(ie,Un),u(qe,Un,null),t(W,Ws),t(W,Rn),t(Rn,Xs),f(e,Zo,l),f(e,ae,l),t(ae,Vn),t(Vn,Le),t(Le,Hn),t(Hn,Ks),t(Le,Zs),t(Le,Wn),t(Wn,Js),t(ae,Ys),t(ae,Xn),t(Xn,Ce),t(Ce,Kn),t(Kn,Ae),t(Ae,Qs),t(Ce,er),t(Ce,Zn),t(Zn,Jn),t(Jn,tr),f(e,Jo,l),f(e,X,l),t(X,se),t(se,Yn),u(Ne,Yn,null),t(X,nr),t(X,Qn),t(Qn,or),f(e,Yo,l),f(e,K,l),t(K,re),t(re,eo),u(Me,eo,null),t(K,ir),t(K,to),t(to,ar),f(e,Qo,l),f(e,le,l),t(le,sr),t(le,no),t(no,rr),t(le,lr),f(e,ei,l),f(e,Gt,l),t(Gt,pr),f(e,ti,l),u(Oe,e,l),f(e,ni,l),f(e,zt,l),t(zt,dr),f(e,oi,l),u(Ge,e,l),f(e,ii,l),f(e,Ft,l),t(Ft,fr),f(e,ai,l),u(ze,e,l),f(e,si,l),f(e,Bt,l),t(Bt,cr),f(e,ri,l),u(Fe,e,l),f(e,li,l),f(e,Ut,l),t(Ut,mr),f(e,pi,l),u(Be,e,l),f(e,di,l),f(e,Z,l),t(Z,pe),t(pe,oo),u(Ue,oo,null),t(Z,gr),t(Z,io),t(io,ur),f(e,fi,l),f(e,de,l),t(de,hr),t(de,Re),t(Re,_r),t(de,vr),f(e,ci,l),f(e,Rt,l),t(Rt,br),f(e,mi,l),u(Ve,e,l),f(e,gi,l),f(e,Vt,l),t(Vt,wr),f(e,ui,l),u(He,e,l),f(e,hi,l),f(e,Ht,l),t(Ht,yr),f(e,_i,l),u(We,e,l),f(e,vi,l),f(e,Wt,l),t(Wt,Er),f(e,bi,l),u(Xe,e,l),f(e,wi,l),f(e,Xt,l),t(Xt,kr),f(e,yi,l),u(Ke,e,l),f(e,Ei,l),f(e,J,l),t(J,fe),t(fe,ao),u(Ze,ao,null),t(J,Dr),t(J,so),t(so,$r),f(e,ki,l),f(e,ce,l),t(ce,xr),t(ce,Je),t(Je,Pr),t(ce,Ir),f(e,Di,l),f(e,Ye,l),t(Ye,ro),t(ro,Sr),t(Ye,jr),f(e,$i,l),u(Qe,e,l),f(e,xi,l),f(e,et,l),t(et,lo),t(lo,Tr),t(et,qr),f(e,Pi,l),u(tt,e,l),f(e,Ii,l),f(e,Kt,l),t(Kt,Lr),f(e,Si,l),f(e,nt,l),t(nt,po),t(po,Cr),t(nt,Ar),f(e,ji,l),f(e,Zt,l),t(Zt,Nr),f(e,Ti,l),u(ot,e,l),f(e,qi,l),f(e,Jt,l),t(Jt,Mr),f(e,Li,l),u(it,e,l),f(e,Ci,l),f(e,A,l),t(A,Or),t(A,fo),t(fo,Gr),t(A,zr),t(A,at),t(at,Fr),t(A,Br),f(e,Ai,l),f(e,st,l),t(st,co),t(co,Ur),t(st,Rr),f(e,Ni,l),f(e,Yt,l),t(Yt,Vr),f(e,Mi,l),u(rt,e,l),f(e,Oi,l),f(e,lt,l),t(lt,mo),t(mo,Hr),t(lt,Wr),f(e,Gi,l),u(pt,e,l),f(e,zi,l),f(e,Qt,l),t(Qt,Xr),f(e,Fi,l),u(dt,e,l),f(e,Bi,l),f(e,Y,l),t(Y,me),t(me,go),u(ft,go,null),t(Y,Kr),t(Y,uo),t(uo,Zr),f(e,Ui,l),f(e,b,l),u(ct,b,null),t(b,Jr),t(b,mt),t(mt,Yr),t(mt,ho),t(ho,Qr),t(mt,el),t(b,tl),t(b,gt),t(gt,nl),t(gt,en),t(en,ol),t(gt,il),t(b,al),t(b,_o),t(_o,sl),t(b,rl),t(b,ut),t(ut,ht),t(ht,vo),t(vo,ll),t(ht,pl),t(ht,tn),t(tn,dl),t(ut,fl),t(ut,_t),t(_t,bo),t(bo,cl),t(_t,ml),t(_t,nn),t(nn,gl),t(b,ul),t(b,wo),t(wo,hl),t(b,_l),t(b,yo),t(yo,vt),t(vt,Eo),t(Eo,vl),t(vt,bl),t(vt,on),t(on,wl),t(b,yl),t(b,N),u(bt,N,null),t(N,El),t(N,ko),t(ko,kl),t(N,Dl),t(N,Do),t(Do,$l),t(b,xl),t(b,M),u(wt,M,null),t(M,Pl),t(M,$o),t($o,Il),t(M,Sl),u(ge,M,null),t(b,jl),t(b,ue),u(yt,ue,null),t(ue,Tl),t(ue,Et),t(Et,ql),t(Et,xo),t(xo,Ll),t(Et,Cl),t(b,Al),t(b,he),u(kt,he,null),t(he,Nl),t(he,Dt),t(Dt,Ml),t(Dt,Po),t(Po,Ol),t(Dt,Gl),t(b,zl),t(b,_e),u($t,_e,null),t(_e,Fl),t(_e,I),t(I,Bl),t(I,Io),t(Io,Ul),t(I,Rl),t(I,So),t(So,Vl),t(I,Hl),t(I,jo),t(jo,Wl),t(I,Xl),t(I,To),t(To,Kl),t(I,Zl),t(b,Jl),t(b,ve),u(xt,ve,null),t(ve,Yl),t(ve,Q),t(Q,Ql),t(Q,qo),t(qo,ep),t(Q,tp),t(Q,Lo),t(Lo,np),t(Q,op),t(b,ip),t(b,O),u(Pt,O,null),t(O,ap),t(O,Co),t(Co,sp),t(O,rp),t(O,Ao),t(Ao,lp),t(b,pp),t(b,G),u(It,G,null),t(G,dp),t(G,No),t(No,fp),t(G,cp),t(G,Mo),t(Mo,mp),f(e,Ri,l),f(e,an,l),t(an,Oo),t(Oo,Go),t(Go,gp),Vi=!0},p(e,[l]){const St={};l&2&&(St.$$scope={dirty:l,ctx:e}),ge.$set(St)},i(e){Vi||(h(Ee.$$.fragment,e),h(ke.$$.fragment,e),h(Se.$$.fragment,e),h(qe.$$.fragment,e),h(Ne.$$.fragment,e),h(Me.$$.fragment,e),h(Oe.$$.fragment,e),h(Ge.$$.fragment,e),h(ze.$$.fragment,e),h(Fe.$$.fragment,e),h(Be.$$.fragment,e),h(Ue.$$.fragment,e),h(Ve.$$.fragment,e),h(He.$$.fragment,e),h(We.$$.fragment,e),h(Xe.$$.fragment,e),h(Ke.$$.fragment,e),h(Ze.$$.fragment,e),h(Qe.$$.fragment,e),h(tt.$$.fragment,e),h(ot.$$.fragment,e),h(it.$$.fragment,e),h(rt.$$.fragment,e),h(pt.$$.fragment,e),h(dt.$$.fragment,e),h(ft.$$.fragment,e),h(ct.$$.fragment,e),h(bt.$$.fragment,e),h(wt.$$.fragment,e),h(ge.$$.fragment,e),h(yt.$$.fragment,e),h(kt.$$.fragment,e),h($t.$$.fragment,e),h(xt.$$.fragment,e),h(Pt.$$.fragment,e),h(It.$$.fragment,e),Vi=!0)},o(e){_(Ee.$$.fragment,e),_(ke.$$.fragment,e),_(Se.$$.fragment,e),_(qe.$$.fragment,e),_(Ne.$$.fragment,e),_(Me.$$.fragment,e),_(Oe.$$.fragment,e),_(Ge.$$.fragment,e),_(ze.$$.fragment,e),_(Fe.$$.fragment,e),_(Be.$$.fragment,e),_(Ue.$$.fragment,e),_(Ve.$$.fragment,e),_(He.$$.fragment,e),_(We.$$.fragment,e),_(Xe.$$.fragment,e),_(Ke.$$.fragment,e),_(Ze.$$.fragment,e),_(Qe.$$.fragment,e),_(tt.$$.fragment,e),_(ot.$$.fragment,e),_(it.$$.fragment,e),_(rt.$$.fragment,e),_(pt.$$.fragment,e),_(dt.$$.fragment,e),_(ft.$$.fragment,e),_(ct.$$.fragment,e),_(bt.$$.fragment,e),_(wt.$$.fragment,e),_(ge.$$.fragment,e),_(yt.$$.fragment,e),_(kt.$$.fragment,e),_($t.$$.fragment,e),_(xt.$$.fragment,e),_(Pt.$$.fragment,e),_(It.$$.fragment,e),Vi=!1},d(e){n(D),e&&n(B),e&&n(y),v(Ee),e&&n(Fo),e&&n(U),v(ke),e&&n(Bo),e&&n(De),e&&n(Uo),e&&n(jt),e&&n(Ro),e&&n(Tt),e&&n(Vo),e&&n(qt),e&&n(Ho),e&&n(C),e&&n(Wo),e&&n(R),v(Se),e&&n(Xo),e&&n(E),e&&n(Ko),e&&n(W),v(qe),e&&n(Zo),e&&n(ae),e&&n(Jo),e&&n(X),v(Ne),e&&n(Yo),e&&n(K),v(Me),e&&n(Qo),e&&n(le),e&&n(ei),e&&n(Gt),e&&n(ti),v(Oe,e),e&&n(ni),e&&n(zt),e&&n(oi),v(Ge,e),e&&n(ii),e&&n(Ft),e&&n(ai),v(ze,e),e&&n(si),e&&n(Bt),e&&n(ri),v(Fe,e),e&&n(li),e&&n(Ut),e&&n(pi),v(Be,e),e&&n(di),e&&n(Z),v(Ue),e&&n(fi),e&&n(de),e&&n(ci),e&&n(Rt),e&&n(mi),v(Ve,e),e&&n(gi),e&&n(Vt),e&&n(ui),v(He,e),e&&n(hi),e&&n(Ht),e&&n(_i),v(We,e),e&&n(vi),e&&n(Wt),e&&n(bi),v(Xe,e),e&&n(wi),e&&n(Xt),e&&n(yi),v(Ke,e),e&&n(Ei),e&&n(J),v(Ze),e&&n(ki),e&&n(ce),e&&n(Di),e&&n(Ye),e&&n($i),v(Qe,e),e&&n(xi),e&&n(et),e&&n(Pi),v(tt,e),e&&n(Ii),e&&n(Kt),e&&n(Si),e&&n(nt),e&&n(ji),e&&n(Zt),e&&n(Ti),v(ot,e),e&&n(qi),e&&n(Jt),e&&n(Li),v(it,e),e&&n(Ci),e&&n(A),e&&n(Ai),e&&n(st),e&&n(Ni),e&&n(Yt),e&&n(Mi),v(rt,e),e&&n(Oi),e&&n(lt),e&&n(Gi),v(pt,e),e&&n(zi),e&&n(Qt),e&&n(Fi),v(dt,e),e&&n(Bi),e&&n(Y),v(ft),e&&n(Ui),e&&n(b),v(ct),v(bt),v(wt),v(ge),v(yt),v(kt),v($t),v(xt),v(Pt),v(It),e&&n(Ri),e&&n(an)}}}const Wf={local:"zeroshot-diffusionbased-semantic-image-editing-with-mask-guidance",sections:[{local:"overview",title:"Overview"},{local:"tips",title:"Tips "},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",sections:[{local:"based-on-an-input-image-with-a-caption",title:"Based on an input image with a caption"}],title:"Usage example"},{local:"generating-image-captions-for-inversion",title:"Generating image captions for inversion"},{local:"generating-source-and-target-embeddings",title:"Generating source and target embeddings "},{local:"diffusers.StableDiffusionDiffEditPipeline",title:"StableDiffusionDiffEditPipeline"}],title:"Zero-shot Diffusion-based Semantic Image Editing with Mask Guidance"};function Xf(zo){return Bf(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ec extends Of{constructor(D){super();Gf(this,D,Xf,Hf,zf,{})}}export{ec as default,Wf as metadata};
