import{S as Xp,i as Zp,s as eh,e as r,k as c,w as $,t as o,M as th,c as n,d as t,m as _,a as i,x as v,h as s,b as u,N as ah,G as a,g as h,y as b,q as w,o as E,B as y,v as oh,L as Pa}from"../../chunks/vendor-hf-doc-builder.js";import{T as Qp}from"../../chunks/Tip-hf-doc-builder.js";import{I as Y}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as sh}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";import{F as ol,M as Sa}from"../../chunks/Markdown-hf-doc-builder.js";function rh(A){let f,d,p,g,D;return{c(){f=r("p"),d=o("DreamBooth finetuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),p=r("a"),g=o("in-depth analysis"),D=o(" with recommended settings for different subjects to help you choose the appropriate hyperparameters."),this.h()},l(S){f=n(S,"P",{});var x=i(f);d=s(x,"DreamBooth finetuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),p=n(x,"A",{href:!0,rel:!0});var U=i(p);g=s(U,"in-depth analysis"),U.forEach(t),D=s(x," with recommended settings for different subjects to help you choose the appropriate hyperparameters."),x.forEach(t),this.h()},h(){u(p,"href","https://huggingface.co/blog/dreambooth"),u(p,"rel","nofollow")},m(S,x){h(S,f,x),a(f,d),a(f,p),a(p,g),a(f,D)},d(S){S&&t(f)}}}function nh(A){let f,d,p,g,D,S,x,U,W,O,M,j,G,R,ee,ue,J,L,K,re,Q,B,te,F,V,H,N,ce,T,z,_e,ae,I,oe;return V=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export OUTPUT_DIR="path_to_saved_model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>`}}),I=new P({props:{code:`accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400 \\
  --push_to_hub`,highlighted:`accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400 \\
  --push_to_hub`}}),{c(){f=r("p"),d=o("Set the "),p=r("code"),g=o("INSTANCE_DIR"),D=o(" environment variable to the path of the directory containing the dog images."),S=c(),x=r("p"),U=o("Specify the "),W=r("code"),O=o("MODEL_NAME"),M=o(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),j=r("code"),G=o("pretrained_model_name_or_path"),R=o(" argument. The "),ee=r("code"),ue=o("instance_prompt"),J=o(" argument is a text prompt that contains a unique identifier, such as "),L=r("code"),K=o("sks"),re=o(", and the class the image belongs to, which in this example is "),Q=r("code"),B=o("a photo of a sks dog"),te=o("."),F=c(),$(V.$$.fragment),H=c(),N=r("p"),ce=o("Then you can launch the training script (you can find the full training script "),T=r("a"),z=o("here"),_e=o(") with the following command:"),ae=c(),$(I.$$.fragment),this.h()},l(m){f=n(m,"P",{});var k=i(f);d=s(k,"Set the "),p=n(k,"CODE",{});var X=i(p);g=s(X,"INSTANCE_DIR"),X.forEach(t),D=s(k," environment variable to the path of the directory containing the dog images."),k.forEach(t),S=_(m),x=n(m,"P",{});var C=i(x);U=s(C,"Specify the "),W=n(C,"CODE",{});var q=i(W);O=s(q,"MODEL_NAME"),q.forEach(t),M=s(C," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),j=n(C,"CODE",{});var ve=i(j);G=s(ve,"pretrained_model_name_or_path"),ve.forEach(t),R=s(C," argument. The "),ee=n(C,"CODE",{});var be=i(ee);ue=s(be,"instance_prompt"),be.forEach(t),J=s(C," argument is a text prompt that contains a unique identifier, such as "),L=n(C,"CODE",{});var de=i(L);K=s(de,"sks"),de.forEach(t),re=s(C,", and the class the image belongs to, which in this example is "),Q=n(C,"CODE",{});var se=i(Q);B=s(se,"a photo of a sks dog"),se.forEach(t),te=s(C,"."),C.forEach(t),F=_(m),v(V.$$.fragment,m),H=_(m),N=n(m,"P",{});var ne=i(N);ce=s(ne,"Then you can launch the training script (you can find the full training script "),T=n(ne,"A",{href:!0,rel:!0});var Z=i(T);z=s(Z,"here"),Z.forEach(t),_e=s(ne,") with the following command:"),ne.forEach(t),ae=_(m),v(I.$$.fragment,m),this.h()},h(){u(T,"href","https://github.com/huggingface/diffusers/blob/main/examples/dreambooth/train_dreambooth.py"),u(T,"rel","nofollow")},m(m,k){h(m,f,k),a(f,d),a(f,p),a(p,g),a(f,D),h(m,S,k),h(m,x,k),a(x,U),a(x,W),a(W,O),a(x,M),a(x,j),a(j,G),a(x,R),a(x,ee),a(ee,ue),a(x,J),a(x,L),a(L,K),a(x,re),a(x,Q),a(Q,B),a(x,te),h(m,F,k),b(V,m,k),h(m,H,k),h(m,N,k),a(N,ce),a(N,T),a(T,z),a(N,_e),h(m,ae,k),b(I,m,k),oe=!0},p:Pa,i(m){oe||(w(V.$$.fragment,m),w(I.$$.fragment,m),oe=!0)},o(m){E(V.$$.fragment,m),E(I.$$.fragment,m),oe=!1},d(m){m&&t(f),m&&t(S),m&&t(x),m&&t(F),y(V,m),m&&t(H),m&&t(N),m&&t(ae),y(I,m)}}}function ih(A){let f,d;return f=new Sa({props:{$$slots:{default:[nh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function lh(A){let f,d,p,g,D,S,x,U,W,O,M,j,G,R,ee,ue,J,L,K,re,Q,B,te,F,V,H,N,ce,T,z,_e,ae,I,oe;return O=new P({props:{code:"pip install -U -r requirements.txt",highlighted:"pip install -U -r requirements.txt"}}),I=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="./dog"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --max_train_steps=400`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --max_train_steps=400`}}),{c(){f=r("p"),d=o("If you have access to TPUs or want to train even faster, you can try out the "),p=r("a"),g=o("Flax training script"),D=o(". The Flax training script doesn\u2019t support gradient checkpointing or gradient accumulation, so you\u2019ll need a GPU with at least 30GB of memory."),S=c(),x=r("p"),U=o("Before running the script, make sure you have the requirements installed:"),W=c(),$(O.$$.fragment),M=c(),j=r("p"),G=o("Specify the "),R=r("code"),ee=o("MODEL_NAME"),ue=o(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),J=r("code"),L=o("pretrained_model_name_or_path"),K=o(" argument. The "),re=r("code"),Q=o("instance_prompt"),B=o(" argument is a text prompt that contains a unique identifier, such as "),te=r("code"),F=o("sks"),V=o(", and the class the image belongs to, which in this example is "),H=r("code"),N=o("a photo of a sks dog"),ce=o("."),T=c(),z=r("p"),_e=o("Now you can launch the training script with the following command:"),ae=c(),$(I.$$.fragment),this.h()},l(m){f=n(m,"P",{});var k=i(f);d=s(k,"If you have access to TPUs or want to train even faster, you can try out the "),p=n(k,"A",{href:!0,rel:!0});var X=i(p);g=s(X,"Flax training script"),X.forEach(t),D=s(k,". The Flax training script doesn\u2019t support gradient checkpointing or gradient accumulation, so you\u2019ll need a GPU with at least 30GB of memory."),k.forEach(t),S=_(m),x=n(m,"P",{});var C=i(x);U=s(C,"Before running the script, make sure you have the requirements installed:"),C.forEach(t),W=_(m),v(O.$$.fragment,m),M=_(m),j=n(m,"P",{});var q=i(j);G=s(q,"Specify the "),R=n(q,"CODE",{});var ve=i(R);ee=s(ve,"MODEL_NAME"),ve.forEach(t),ue=s(q," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),J=n(q,"CODE",{});var be=i(J);L=s(be,"pretrained_model_name_or_path"),be.forEach(t),K=s(q," argument. The "),re=n(q,"CODE",{});var de=i(re);Q=s(de,"instance_prompt"),de.forEach(t),B=s(q," argument is a text prompt that contains a unique identifier, such as "),te=n(q,"CODE",{});var se=i(te);F=s(se,"sks"),se.forEach(t),V=s(q,", and the class the image belongs to, which in this example is "),H=n(q,"CODE",{});var ne=i(H);N=s(ne,"a photo of a sks dog"),ne.forEach(t),ce=s(q,"."),q.forEach(t),T=_(m),z=n(m,"P",{});var Z=i(z);_e=s(Z,"Now you can launch the training script with the following command:"),Z.forEach(t),ae=_(m),v(I.$$.fragment,m),this.h()},h(){u(p,"href","https://github.com/huggingface/diffusers/blob/main/examples/dreambooth/train_dreambooth_flax.py"),u(p,"rel","nofollow")},m(m,k){h(m,f,k),a(f,d),a(f,p),a(p,g),a(f,D),h(m,S,k),h(m,x,k),a(x,U),h(m,W,k),b(O,m,k),h(m,M,k),h(m,j,k),a(j,G),a(j,R),a(R,ee),a(j,ue),a(j,J),a(J,L),a(j,K),a(j,re),a(re,Q),a(j,B),a(j,te),a(te,F),a(j,V),a(j,H),a(H,N),a(j,ce),h(m,T,k),h(m,z,k),a(z,_e),h(m,ae,k),b(I,m,k),oe=!0},p:Pa,i(m){oe||(w(O.$$.fragment,m),w(I.$$.fragment,m),oe=!0)},o(m){E(O.$$.fragment,m),E(I.$$.fragment,m),oe=!1},d(m){m&&t(f),m&&t(S),m&&t(x),m&&t(W),y(O,m),m&&t(M),m&&t(j),m&&t(T),m&&t(z),m&&t(ae),y(I,m)}}}function ph(A){let f,d;return f=new Sa({props:{$$slots:{default:[lh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function hh(A){let f,d;return f=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p:Pa,i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function fh(A){let f,d;return f=new Sa({props:{$$slots:{default:[hh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function uh(A){let f,d;return f=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p:Pa,i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function ch(A){let f,d;return f=new Sa({props:{$$slots:{default:[uh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function _h(A){let f,d;return{c(){f=r("p"),d=o("Training the text encoder requires additional memory and it won\u2019t fit on a 16GB GPU. You\u2019ll need at least 24GB VRAM to use this option.")},l(p){f=n(p,"P",{});var g=i(f);d=s(g,"Training the text encoder requires additional memory and it won\u2019t fit on a 16GB GPU. You\u2019ll need at least 24GB VRAM to use this option."),g.forEach(t)},m(p,g){h(p,f,g),a(f,d)},d(p){p&&t(f)}}}function mh(A){let f,d;return f=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --train_text_encoder \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --train_text_encoder \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p:Pa,i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function dh(A){let f,d;return f=new Sa({props:{$$slots:{default:[mh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function gh(A){let f,d;return f=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --train_text_encoder \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=2e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --train_text_encoder \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=2e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p:Pa,i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function $h(A){let f,d;return f=new Sa({props:{$$slots:{default:[gh]},$$scope:{ctx:A}}}),{c(){$(f.$$.fragment)},l(p){v(f.$$.fragment,p)},m(p,g){b(f,p,g),d=!0},p(p,g){const D={};g&2&&(D.$$scope={dirty:g,ctx:p}),f.$set(D)},i(p){d||(w(f.$$.fragment,p),d=!0)},o(p){E(f.$$.fragment,p),d=!1},d(p){y(f,p)}}}function vh(A){let f,d,p,g,D,S,x,U,W,O,M,j,G,R,ee,ue,J,L,K,re,Q,B,te,F,V,H,N,ce,T,z,_e,ae,I,oe,m,k,X,C,q,ve,be,de,se,ne,Z,xr,pa,Ar,jr,To,Ce,Pr,bt,Sr,Nr,Co,wt,Ro,ha,Ir,Uo,Et,Oo,fa,qr,Mo,yt,Lo,Re,Tr,kt,Cr,Rr,zo,Dt,Go,Ue,Ur,ua,Or,Mr,Bo,we,Oe,Na,xt,Lr,Ia,zr,Fo,Me,Vo,Le,Ho,Ee,ze,qa,At,Gr,Ta,Br,Yo,Ge,Fr,jt,Vr,Hr,Wo,Be,Yr,Ca,Wr,Jr,Jo,Fe,Ko,ye,Ve,Ra,Pt,Kr,Ua,Qr,Qo,ie,Xr,Oa,Zr,en,Ma,tn,an,St,on,sn,Xo,He,Zo,le,rn,La,nn,ln,za,pn,hn,Ga,fn,un,es,Ye,ts,ke,We,Ba,Nt,cn,Fa,_n,as,Je,mn,ca,dn,gn,os,De,Ke,Va,It,$n,Ha,vn,ss,_a,bn,rs,qt,ns,pe,wn,Ya,En,yn,Wa,kn,Dn,Ja,xn,An,is,xe,Qe,Ka,Tt,jn,Qa,Pn,ls,ge,Sn,Xa,Nn,In,Za,qn,Tn,ps,Ct,hs,ma,Cn,fs,Ae,Xe,eo,Rt,Rn,to,Un,us,da,On,cs,Ze,Mn,ao,oo,Ln,zn,_s,Ut,ms,et,Gn,so,ro,Bn,Fn,ds,Ot,gs,je,tt,no,Mt,Vn,io,Hn,$s,ga,Yn,vs,Pe,at,lo,Lt,Wn,po,Jn,bs,me,zt,Kn,Qn,Gt,Xn,Zn,$a,ei,ti,ws,Bt,Es,va,ai,ys,Se,ot,ho,Ft,oi,fo,si,ks,he,ri,Vt,ni,ii,uo,li,pi,co,hi,fi,Ds,Ht,xs,Ne,st,_o,Yt,ui,mo,ci,As,rt,_i,Wt,mi,di,js,Jt,Ps,nt,gi,go,$i,vi,Ss,Kt,Ns,Ie,it,$o,Qt,bi,vo,wi,Is,lt,Ei,bo,yi,ki,qs,Xt,Ts,qe,pt,wo,Zt,Di,Eo,xi,Cs,ht,Ai,ea,ji,Pi,Rs,ba,Si,Us,ta,Os,ft,Ni,aa,Ii,qi,Ms,$e,Ti,oa,yo,Ci,Ri,ko,Ui,Oi,Ls,wa,Mi,zs,Ea,Li,Gs,sa,Bs,Te,ut,Do,ra,zi,xo,Gi,Fs,fe,Bi,ya,Fi,Vi,Ao,Hi,Yi,jo,Wi,Ji,Vs,ct,Ki,Po,So,Qi,Xi,Hs,na,Ys,_t,Zi,ka,el,tl,Ws;return S=new Y({}),M=new sh({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/dreambooth.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/dreambooth.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/dreambooth.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/dreambooth.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/dreambooth.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/dreambooth.ipynb"}]}}),se=new P({props:{code:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`}}),wt=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),Et=new P({props:{code:"accelerate config default",highlighted:"accelerate config default"}}),yt=new P({props:{code:`from accelerate.utils import write_basic_config

write_basic_config()`,highlighted:`<span class="hljs-keyword">from</span> accelerate.utils <span class="hljs-keyword">import</span> write_basic_config

write_basic_config()`}}),Dt=new P({props:{code:`from huggingface_hub import snapshot_download

local_dir = "./dog"
snapshot_download(
    "diffusers/dog-example",
    local_dir=local_dir,
    repo_type="dataset",
    ignore_patterns=".gitattributes",
)`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> snapshot_download

local_dir = <span class="hljs-string">&quot;./dog&quot;</span>
snapshot_download(
    <span class="hljs-string">&quot;diffusers/dog-example&quot;</span>,
    local_dir=local_dir,
    repo_type=<span class="hljs-string">&quot;dataset&quot;</span>,
    ignore_patterns=<span class="hljs-string">&quot;.gitattributes&quot;</span>,
)`}}),xt=new Y({}),Me=new Qp({props:{warning:!0,$$slots:{default:[rh]},$$scope:{ctx:A}}}),Le=new ol({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[ph],pytorch:[ih]},$$scope:{ctx:A}}}),At=new Y({}),Fe=new ol({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[ch],pytorch:[fh]},$$scope:{ctx:A}}}),Pt=new Y({}),He=new Qp({props:{warning:!0,$$slots:{default:[_h]},$$scope:{ctx:A}}}),Ye=new ol({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[$h],pytorch:[dh]},$$scope:{ctx:A}}}),Nt=new Y({}),It=new Y({}),qt=new P({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),Tt=new Y({}),Ct=new P({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),Rt=new Y({}),Ut=new P({props:{code:`from diffusers import DiffusionPipeline, UNet2DConditionModel
from transformers import CLIPTextModel
import torch

# Load the pipeline with the same arguments (model, revision) that were used for training
model_id = "CompVis/stable-diffusion-v1-4"

unet = UNet2DConditionModel.from_pretrained("/sddata/dreambooth/daruma-v2-1/checkpoint-100/unet")

# if you have trained with \`--args.train_text_encoder\` make sure to also load the text encoder
text_encoder = CLIPTextModel.from_pretrained("/sddata/dreambooth/daruma-v2-1/checkpoint-100/text_encoder")

pipeline = DiffusionPipeline.from_pretrained(model_id, unet=unet, text_encoder=text_encoder, dtype=torch.float16)
pipeline.to("cuda")

# Perform inference, or save, or push to the hub
pipeline.save_pretrained("dreambooth-pipeline")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, UNet2DConditionModel
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> CLIPTextModel
<span class="hljs-keyword">import</span> torch

<span class="hljs-comment"># Load the pipeline with the same arguments (model, revision) that were used for training</span>
model_id = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>

unet = UNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100/unet&quot;</span>)

<span class="hljs-comment"># if you have trained with \`--args.train_text_encoder\` make sure to also load the text encoder</span>
text_encoder = CLIPTextModel.from_pretrained(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100/text_encoder&quot;</span>)

pipeline = DiffusionPipeline.from_pretrained(model_id, unet=unet, text_encoder=text_encoder, dtype=torch.float16)
pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># Perform inference, or save, or push to the hub</span>
pipeline.save_pretrained(<span class="hljs-string">&quot;dreambooth-pipeline&quot;</span>)`}}),Ot=new P({props:{code:`from accelerate import Accelerator
from diffusers import DiffusionPipeline

# Load the pipeline with the same arguments (model, revision) that were used for training
model_id = "CompVis/stable-diffusion-v1-4"
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

# Use text_encoder if \`--train_text_encoder\` was used for the initial training
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

# Restore state from a checkpoint path. You have to use the absolute path here.
accelerator.load_state("/sddata/dreambooth/daruma-v2-1/checkpoint-100")

# Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

# Perform inference, or save, or push to the hub
pipeline.save_pretrained("dreambooth-pipeline")`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-comment"># Load the pipeline with the same arguments (model, revision) that were used for training</span>
model_id = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

<span class="hljs-comment"># Use text_encoder if \`--train_text_encoder\` was used for the initial training</span>
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

<span class="hljs-comment"># Restore state from a checkpoint path. You have to use the absolute path here.</span>
accelerator.load_state(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100&quot;</span>)

<span class="hljs-comment"># Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)</span>
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

<span class="hljs-comment"># Perform inference, or save, or push to the hub</span>
pipeline.save_pretrained(<span class="hljs-string">&quot;dreambooth-pipeline&quot;</span>)`}}),Mt=new Y({}),Lt=new Y({}),Bt=new P({props:{code:"  --enable_xformers_memory_efficient_attention",highlighted:"  --enable_xformers_memory_efficient_attention"}}),Ft=new Y({}),Ht=new P({props:{code:"  --set_grads_to_none",highlighted:"  --set_grads_to_none"}}),Yt=new Y({}),Jt=new P({props:{code:"pip install bitsandbytes",highlighted:"pip install bitsandbytes"}}),Kt=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`}}),Qt=new Y({}),Xt=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --use_8bit_adam \\
  --enable_xformers_memory_efficient_attention \\
  --set_grads_to_none \\
  --learning_rate=2e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --use_8bit_adam \\
  --enable_xformers_memory_efficient_attention \\
  --set_grads_to_none \\
  --learning_rate=2e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --push_to_hub`}}),Zt=new Y({}),ta=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),sa=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="./dog"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16 \\
  --push_to_hub`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;./dog&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16 \\
  --push_to_hub`}}),ra=new Y({}),na=new P({props:{code:`from diffusers import DiffusionPipeline
import torch

model_id = "path_to_saved_model"
pipe = DiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

prompt = "A photo of sks dog in a bucket"
image = pipe(prompt, num_inference_steps=50, guidance_scale=7.5).images[0]

image.save("dog-bucket.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = DiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;A photo of sks dog in a bucket&quot;</span>
image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>, guidance_scale=<span class="hljs-number">7.5</span>).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;dog-bucket.png&quot;</span>)`}}),{c(){f=r("meta"),d=c(),p=r("h1"),g=r("a"),D=r("span"),$(S.$$.fragment),x=c(),U=r("span"),W=o("DreamBooth"),O=c(),$(M.$$.fragment),j=c(),G=r("p"),R=r("a"),ee=o("DreamBooth"),ue=o(" is a method to personalize text-to-image models like Stable Diffusion given just a few (3-5) images of a subject. It allows the model to generate contextualized images of the subject in different scenes, poses, and views."),J=c(),L=r("p"),K=r("img"),Q=c(),B=r("small"),te=o("Dreambooth examples from the "),F=r("a"),V=o("project's blog."),H=c(),N=r("p"),ce=o("This guide will show you how to finetune DreamBooth with the "),T=r("a"),z=r("code"),_e=o("CompVis/stable-diffusion-v1-4"),ae=o(" model for various GPU sizes, and with Flax. All the training scripts for DreamBooth used in this guide can be found "),I=r("a"),oe=o("here"),m=o(" if you\u2019re interested in digging deeper and seeing how things work."),k=c(),X=r("p"),C=o("Before running the scripts, make sure you install the library\u2019s training dependencies. We also recommend installing \u{1F9E8} Diffusers from the "),q=r("code"),ve=o("main"),be=o(" GitHub branch:"),de=c(),$(se.$$.fragment),ne=c(),Z=r("p"),xr=o("xFormers is not part of the training requirements, but we recommend you "),pa=r("a"),Ar=o("install"),jr=o(" it if you can because it could make your training faster and less memory intensive."),To=c(),Ce=r("p"),Pr=o("After all the dependencies have been set up, initialize a "),bt=r("a"),Sr=o("\u{1F917} Accelerate"),Nr=o(" environment with:"),Co=c(),$(wt.$$.fragment),Ro=c(),ha=r("p"),Ir=o("To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),Uo=c(),$(Et.$$.fragment),Oo=c(),fa=r("p"),qr=o("Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),Mo=c(),$(yt.$$.fragment),Lo=c(),Re=r("p"),Tr=o("Finally, download a "),kt=r("a"),Cr=o("few images of a dog"),Rr=o(" to DreamBooth with:"),zo=c(),$(Dt.$$.fragment),Go=c(),Ue=r("p"),Ur=o("To use your own dataset, take a look at the "),ua=r("a"),Or=o("Create a dataset for training"),Mr=o(" guide."),Bo=c(),we=r("h2"),Oe=r("a"),Na=r("span"),$(xt.$$.fragment),Lr=c(),Ia=r("span"),zr=o("Finetuning"),Fo=c(),$(Me.$$.fragment),Vo=c(),$(Le.$$.fragment),Ho=c(),Ee=r("h2"),ze=r("a"),qa=r("span"),$(At.$$.fragment),Gr=c(),Ta=r("span"),Br=o("Finetuning with prior-preserving loss"),Yo=c(),Ge=r("p"),Fr=o("Prior preservation is used to avoid overfitting and language-drift (check out the "),jt=r("a"),Vr=o("paper"),Hr=o(" to learn more if you\u2019re interested). For prior preservation, you use other images of the same class as part of the training process. The nice thing is that you can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path you specify."),Wo=c(),Be=r("p"),Yr=o("The authors recommend generating "),Ca=r("code"),Wr=o("num_epochs * num_samples"),Jr=o(" images for prior preservation. In most cases, 200-300 images work well."),Jo=c(),$(Fe.$$.fragment),Ko=c(),ye=r("h2"),Ve=r("a"),Ra=r("span"),$(Pt.$$.fragment),Kr=c(),Ua=r("span"),Qr=o("Finetuning the text encoder and UNet"),Qo=c(),ie=r("p"),Xr=o("The script also allows you to finetune the "),Oa=r("code"),Zr=o("text_encoder"),en=o(" along with the "),Ma=r("code"),tn=o("unet"),an=o(". In our experiments (check out the "),St=r("a"),on=o("Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),sn=o(" post for more details), this yields much better results, especially when generating images of faces."),Xo=c(),$(He.$$.fragment),Zo=c(),le=r("p"),rn=o("Pass the "),La=r("code"),nn=o("--train_text_encoder"),ln=o(" argument to the training script to enable finetuning the "),za=r("code"),pn=o("text_encoder"),hn=o(" and "),Ga=r("code"),fn=o("unet"),un=o(":"),es=c(),$(Ye.$$.fragment),ts=c(),ke=r("h2"),We=r("a"),Ba=r("span"),$(Nt.$$.fragment),cn=c(),Fa=r("span"),_n=o("Finetuning with LoRA"),as=c(),Je=r("p"),mn=o("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, on DreamBooth. For more details, take a look at the "),ca=r("a"),dn=o("LoRA training"),gn=o(" guide."),os=c(),De=r("h2"),Ke=r("a"),Va=r("span"),$(It.$$.fragment),$n=c(),Ha=r("span"),vn=o("Saving checkpoints while training"),ss=c(),_a=r("p"),bn=o("It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the training process. One of the intermediate checkpoints might actually work better than the final model! Pass the following argument to the training script to enable saving checkpoints:"),rs=c(),$(qt.$$.fragment),ns=c(),pe=r("p"),wn=o("This saves the full training state in subfolders of your "),Ya=r("code"),En=o("output_dir"),yn=o(". Subfolder names begin with the prefix "),Wa=r("code"),kn=o("checkpoint-"),Dn=o(", followed by the number of steps performed so far; for example, "),Ja=r("code"),xn=o("checkpoint-1500"),An=o(" would be a checkpoint saved after 1500 training steps."),is=c(),xe=r("h3"),Qe=r("a"),Ka=r("span"),$(Tt.$$.fragment),jn=c(),Qa=r("span"),Pn=o("Resume training from a saved checkpoint"),ls=c(),ge=r("p"),Sn=o("If you want to resume training from any of the saved checkpoints, you can pass the argument "),Xa=r("code"),Nn=o("--resume_from_checkpoint"),In=o(" to the script and specify the name of the checkpoint you want to use. You can also use the special string "),Za=r("code"),qn=o('"latest"'),Tn=o(" to resume from the last saved checkpoint (the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),ps=c(),$(Ct.$$.fragment),hs=c(),ma=r("p"),Cn=o("This is a good opportunity to tweak some of your hyperparameters if you wish."),fs=c(),Ae=r("h3"),Xe=r("a"),eo=r("span"),$(Rt.$$.fragment),Rn=c(),to=r("span"),Un=o("Inference from a saved checkpoint"),us=c(),da=r("p"),On=o("Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders, and learning rate."),cs=c(),Ze=r("p"),Mn=o("If you have "),ao=r("strong"),oo=r("code"),Ln=o('"accelerate>=0.16.0"'),zn=o(` installed, use the following code to run
inference from an intermediate checkpoint.`),_s=c(),$(Ut.$$.fragment),ms=c(),et=r("p"),Gn=o("If you have "),so=r("strong"),ro=r("code"),Bn=o('"accelerate<0.16.0"'),Fn=o(" installed, you need to convert it to an inference pipeline first:"),ds=c(),$(Ot.$$.fragment),gs=c(),je=r("h2"),tt=r("a"),no=r("span"),$(Mt.$$.fragment),Vn=c(),io=r("span"),Hn=o("Optimizations for different GPU sizes"),$s=c(),ga=r("p"),Yn=o("Depending on your hardware, there are a few different ways to optimize DreamBooth on GPUs from 16GB to just 8GB!"),vs=c(),Pe=r("h3"),at=r("a"),lo=r("span"),$(Lt.$$.fragment),Wn=c(),po=r("span"),Jn=o("xFormers"),bs=c(),me=r("p"),zt=r("a"),Kn=o("xFormers"),Qn=o(" is a toolbox for optimizing Transformers, and it includes a "),Gt=r("a"),Xn=o("memory-efficient attention"),Zn=o(" mechanism that is used in \u{1F9E8} Diffusers. You\u2019ll need to "),$a=r("a"),ei=o("install xFormers"),ti=o(" and then add the following argument to your training script:"),ws=c(),$(Bt.$$.fragment),Es=c(),va=r("p"),ai=o("xFormers is not available in Flax."),ys=c(),Se=r("h3"),ot=r("a"),ho=r("span"),$(Ft.$$.fragment),oi=c(),fo=r("span"),si=o("Set gradients to none"),ks=c(),he=r("p"),ri=o("Another way you can lower your memory footprint is to "),Vt=r("a"),ni=o("set the gradients"),ii=o(" to "),uo=r("code"),li=o("None"),pi=o(" instead of zero. However, this may change certain behaviors, so if you run into any issues, try removing this argument. Add the following argument to your training script to set the gradients to "),co=r("code"),hi=o("None"),fi=o(":"),Ds=c(),$(Ht.$$.fragment),xs=c(),Ne=r("h3"),st=r("a"),_o=r("span"),$(Yt.$$.fragment),ui=c(),mo=r("span"),ci=o("16GB GPU"),As=c(),rt=r("p"),_i=o("With the help of gradient checkpointing and "),Wt=r("a"),mi=o("bitsandbytes"),di=o(" 8-bit optimizer, it\u2019s possible to train DreamBooth on a 16GB GPU. Make sure you have bitsandbytes installed:"),js=c(),$(Jt.$$.fragment),Ps=c(),nt=r("p"),gi=o("Then pass the "),go=r("code"),$i=o("--use_8bit_adam"),vi=o(" option to the training script:"),Ss=c(),$(Kt.$$.fragment),Ns=c(),Ie=r("h3"),it=r("a"),$o=r("span"),$(Qt.$$.fragment),bi=c(),vo=r("span"),wi=o("12GB GPU"),Is=c(),lt=r("p"),Ei=o("To run DreamBooth on a 12GB GPU, you\u2019ll need to enable gradient checkpointing, the 8-bit optimizer, xFormers, and set the gradients to "),bo=r("code"),yi=o("None"),ki=o(":"),qs=c(),$(Xt.$$.fragment),Ts=c(),qe=r("h3"),pt=r("a"),wo=r("span"),$(Zt.$$.fragment),Di=c(),Eo=r("span"),xi=o("8 GB GPU"),Cs=c(),ht=r("p"),Ai=o("For 8GB GPUs, you\u2019ll need the help of "),ea=r("a"),ji=o("DeepSpeed"),Pi=o(` to offload some
tensors from the VRAM to either the CPU or NVME, enabling training with less GPU memory.`),Rs=c(),ba=r("p"),Si=o("Run the following command to configure your \u{1F917} Accelerate environment:"),Us=c(),$(ta.$$.fragment),Os=c(),ft=r("p"),Ni=o("During configuration, confirm that you want to use DeepSpeed. Now it\u2019s possible to train on under 8GB VRAM by combining DeepSpeed stage 2, fp16 mixed precision, and offloading the model parameters and the optimizer state to the CPU. The drawback is that this requires more system RAM, about 25 GB. See "),aa=r("a"),Ii=o("the DeepSpeed documentation"),qi=o(" for more configuration options."),Ms=c(),$e=r("p"),Ti=o(`You should also change the default Adam optimizer to DeepSpeed\u2019s optimized version of Adam
`),oa=r("a"),yo=r("code"),Ci=o("deepspeed.ops.adam.DeepSpeedCPUAdam"),Ri=o(" for a substantial speedup. Enabling "),ko=r("code"),Ui=o("DeepSpeedCPUAdam"),Oi=o(" requires your system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch."),Ls=c(),wa=r("p"),Mi=o("8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment."),zs=c(),Ea=r("p"),Li=o("Launch training with the following command:"),Gs=c(),$(sa.$$.fragment),Bs=c(),Te=r("h2"),ut=r("a"),Do=r("span"),$(ra.$$.fragment),zi=c(),xo=r("span"),Gi=o("Inference"),Fs=c(),fe=r("p"),Bi=o("Once you have trained a model, specify the path to where the model is saved, and use it for inference in the "),ya=r("a"),Fi=o("StableDiffusionPipeline"),Vi=o(". Make sure your prompts include the special "),Ao=r("code"),Hi=o("identifier"),Yi=o(" used during training ("),jo=r("code"),Wi=o("sks"),Ji=o(" in the previous examples)."),Vs=c(),ct=r("p"),Ki=o("If you have "),Po=r("strong"),So=r("code"),Qi=o('"accelerate>=0.16.0"'),Xi=o(` installed, you can use the following code to run
inference from an intermediate checkpoint:`),Hs=c(),$(na.$$.fragment),Ys=c(),_t=r("p"),Zi=o("You may also run inference from any of the "),ka=r("a"),el=o("saved training checkpoints"),tl=o("."),this.h()},l(e){const l=th('[data-svelte="svelte-1phssyn"]',document.head);f=n(l,"META",{name:!0,content:!0}),l.forEach(t),d=_(e),p=n(e,"H1",{class:!0});var ia=i(p);g=n(ia,"A",{id:!0,class:!0,href:!0});var No=i(g);D=n(No,"SPAN",{});var Io=i(D);v(S.$$.fragment,Io),Io.forEach(t),No.forEach(t),x=_(ia),U=n(ia,"SPAN",{});var qo=i(U);W=s(qo,"DreamBooth"),qo.forEach(t),ia.forEach(t),O=_(e),v(M.$$.fragment,e),j=_(e),G=n(e,"P",{});var Da=i(G);R=n(Da,"A",{href:!0,rel:!0});var sl=i(R);ee=s(sl,"DreamBooth"),sl.forEach(t),ue=s(Da," is a method to personalize text-to-image models like Stable Diffusion given just a few (3-5) images of a subject. It allows the model to generate contextualized images of the subject in different scenes, poses, and views."),Da.forEach(t),J=_(e),L=n(e,"P",{});var rl=i(L);K=n(rl,"IMG",{src:!0,alt:!0}),rl.forEach(t),Q=_(e),B=n(e,"SMALL",{});var al=i(B);te=s(al,"Dreambooth examples from the "),F=n(al,"A",{href:!0});var nl=i(F);V=s(nl,"project's blog."),nl.forEach(t),al.forEach(t),H=_(e),N=n(e,"P",{});var xa=i(N);ce=s(xa,"This guide will show you how to finetune DreamBooth with the "),T=n(xa,"A",{href:!0,rel:!0});var il=i(T);z=n(il,"CODE",{});var ll=i(z);_e=s(ll,"CompVis/stable-diffusion-v1-4"),ll.forEach(t),il.forEach(t),ae=s(xa," model for various GPU sizes, and with Flax. All the training scripts for DreamBooth used in this guide can be found "),I=n(xa,"A",{href:!0,rel:!0});var pl=i(I);oe=s(pl,"here"),pl.forEach(t),m=s(xa," if you\u2019re interested in digging deeper and seeing how things work."),xa.forEach(t),k=_(e),X=n(e,"P",{});var Js=i(X);C=s(Js,"Before running the scripts, make sure you install the library\u2019s training dependencies. We also recommend installing \u{1F9E8} Diffusers from the "),q=n(Js,"CODE",{});var hl=i(q);ve=s(hl,"main"),hl.forEach(t),be=s(Js," GitHub branch:"),Js.forEach(t),de=_(e),v(se.$$.fragment,e),ne=_(e),Z=n(e,"P",{});var Ks=i(Z);xr=s(Ks,"xFormers is not part of the training requirements, but we recommend you "),pa=n(Ks,"A",{href:!0});var fl=i(pa);Ar=s(fl,"install"),fl.forEach(t),jr=s(Ks," it if you can because it could make your training faster and less memory intensive."),Ks.forEach(t),To=_(e),Ce=n(e,"P",{});var Qs=i(Ce);Pr=s(Qs,"After all the dependencies have been set up, initialize a "),bt=n(Qs,"A",{href:!0,rel:!0});var ul=i(bt);Sr=s(ul,"\u{1F917} Accelerate"),ul.forEach(t),Nr=s(Qs," environment with:"),Qs.forEach(t),Co=_(e),v(wt.$$.fragment,e),Ro=_(e),ha=n(e,"P",{});var cl=i(ha);Ir=s(cl,"To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),cl.forEach(t),Uo=_(e),v(Et.$$.fragment,e),Oo=_(e),fa=n(e,"P",{});var _l=i(fa);qr=s(_l,"Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),_l.forEach(t),Mo=_(e),v(yt.$$.fragment,e),Lo=_(e),Re=n(e,"P",{});var Xs=i(Re);Tr=s(Xs,"Finally, download a "),kt=n(Xs,"A",{href:!0,rel:!0});var ml=i(kt);Cr=s(ml,"few images of a dog"),ml.forEach(t),Rr=s(Xs," to DreamBooth with:"),Xs.forEach(t),zo=_(e),v(Dt.$$.fragment,e),Go=_(e),Ue=n(e,"P",{});var Zs=i(Ue);Ur=s(Zs,"To use your own dataset, take a look at the "),ua=n(Zs,"A",{href:!0});var dl=i(ua);Or=s(dl,"Create a dataset for training"),dl.forEach(t),Mr=s(Zs," guide."),Zs.forEach(t),Bo=_(e),we=n(e,"H2",{class:!0});var er=i(we);Oe=n(er,"A",{id:!0,class:!0,href:!0});var gl=i(Oe);Na=n(gl,"SPAN",{});var $l=i(Na);v(xt.$$.fragment,$l),$l.forEach(t),gl.forEach(t),Lr=_(er),Ia=n(er,"SPAN",{});var vl=i(Ia);zr=s(vl,"Finetuning"),vl.forEach(t),er.forEach(t),Fo=_(e),v(Me.$$.fragment,e),Vo=_(e),v(Le.$$.fragment,e),Ho=_(e),Ee=n(e,"H2",{class:!0});var tr=i(Ee);ze=n(tr,"A",{id:!0,class:!0,href:!0});var bl=i(ze);qa=n(bl,"SPAN",{});var wl=i(qa);v(At.$$.fragment,wl),wl.forEach(t),bl.forEach(t),Gr=_(tr),Ta=n(tr,"SPAN",{});var El=i(Ta);Br=s(El,"Finetuning with prior-preserving loss"),El.forEach(t),tr.forEach(t),Yo=_(e),Ge=n(e,"P",{});var ar=i(Ge);Fr=s(ar,"Prior preservation is used to avoid overfitting and language-drift (check out the "),jt=n(ar,"A",{href:!0,rel:!0});var yl=i(jt);Vr=s(yl,"paper"),yl.forEach(t),Hr=s(ar," to learn more if you\u2019re interested). For prior preservation, you use other images of the same class as part of the training process. The nice thing is that you can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path you specify."),ar.forEach(t),Wo=_(e),Be=n(e,"P",{});var or=i(Be);Yr=s(or,"The authors recommend generating "),Ca=n(or,"CODE",{});var kl=i(Ca);Wr=s(kl,"num_epochs * num_samples"),kl.forEach(t),Jr=s(or," images for prior preservation. In most cases, 200-300 images work well."),or.forEach(t),Jo=_(e),v(Fe.$$.fragment,e),Ko=_(e),ye=n(e,"H2",{class:!0});var sr=i(ye);Ve=n(sr,"A",{id:!0,class:!0,href:!0});var Dl=i(Ve);Ra=n(Dl,"SPAN",{});var xl=i(Ra);v(Pt.$$.fragment,xl),xl.forEach(t),Dl.forEach(t),Kr=_(sr),Ua=n(sr,"SPAN",{});var Al=i(Ua);Qr=s(Al,"Finetuning the text encoder and UNet"),Al.forEach(t),sr.forEach(t),Qo=_(e),ie=n(e,"P",{});var mt=i(ie);Xr=s(mt,"The script also allows you to finetune the "),Oa=n(mt,"CODE",{});var jl=i(Oa);Zr=s(jl,"text_encoder"),jl.forEach(t),en=s(mt," along with the "),Ma=n(mt,"CODE",{});var Pl=i(Ma);tn=s(Pl,"unet"),Pl.forEach(t),an=s(mt,". In our experiments (check out the "),St=n(mt,"A",{href:!0,rel:!0});var Sl=i(St);on=s(Sl,"Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),Sl.forEach(t),sn=s(mt," post for more details), this yields much better results, especially when generating images of faces."),mt.forEach(t),Xo=_(e),v(He.$$.fragment,e),Zo=_(e),le=n(e,"P",{});var dt=i(le);rn=s(dt,"Pass the "),La=n(dt,"CODE",{});var Nl=i(La);nn=s(Nl,"--train_text_encoder"),Nl.forEach(t),ln=s(dt," argument to the training script to enable finetuning the "),za=n(dt,"CODE",{});var Il=i(za);pn=s(Il,"text_encoder"),Il.forEach(t),hn=s(dt," and "),Ga=n(dt,"CODE",{});var ql=i(Ga);fn=s(ql,"unet"),ql.forEach(t),un=s(dt,":"),dt.forEach(t),es=_(e),v(Ye.$$.fragment,e),ts=_(e),ke=n(e,"H2",{class:!0});var rr=i(ke);We=n(rr,"A",{id:!0,class:!0,href:!0});var Tl=i(We);Ba=n(Tl,"SPAN",{});var Cl=i(Ba);v(Nt.$$.fragment,Cl),Cl.forEach(t),Tl.forEach(t),cn=_(rr),Fa=n(rr,"SPAN",{});var Rl=i(Fa);_n=s(Rl,"Finetuning with LoRA"),Rl.forEach(t),rr.forEach(t),as=_(e),Je=n(e,"P",{});var nr=i(Je);mn=s(nr,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, on DreamBooth. For more details, take a look at the "),ca=n(nr,"A",{href:!0});var Ul=i(ca);dn=s(Ul,"LoRA training"),Ul.forEach(t),gn=s(nr," guide."),nr.forEach(t),os=_(e),De=n(e,"H2",{class:!0});var ir=i(De);Ke=n(ir,"A",{id:!0,class:!0,href:!0});var Ol=i(Ke);Va=n(Ol,"SPAN",{});var Ml=i(Va);v(It.$$.fragment,Ml),Ml.forEach(t),Ol.forEach(t),$n=_(ir),Ha=n(ir,"SPAN",{});var Ll=i(Ha);vn=s(Ll,"Saving checkpoints while training"),Ll.forEach(t),ir.forEach(t),ss=_(e),_a=n(e,"P",{});var zl=i(_a);bn=s(zl,"It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the training process. One of the intermediate checkpoints might actually work better than the final model! Pass the following argument to the training script to enable saving checkpoints:"),zl.forEach(t),rs=_(e),v(qt.$$.fragment,e),ns=_(e),pe=n(e,"P",{});var gt=i(pe);wn=s(gt,"This saves the full training state in subfolders of your "),Ya=n(gt,"CODE",{});var Gl=i(Ya);En=s(Gl,"output_dir"),Gl.forEach(t),yn=s(gt,". Subfolder names begin with the prefix "),Wa=n(gt,"CODE",{});var Bl=i(Wa);kn=s(Bl,"checkpoint-"),Bl.forEach(t),Dn=s(gt,", followed by the number of steps performed so far; for example, "),Ja=n(gt,"CODE",{});var Fl=i(Ja);xn=s(Fl,"checkpoint-1500"),Fl.forEach(t),An=s(gt," would be a checkpoint saved after 1500 training steps."),gt.forEach(t),is=_(e),xe=n(e,"H3",{class:!0});var lr=i(xe);Qe=n(lr,"A",{id:!0,class:!0,href:!0});var Vl=i(Qe);Ka=n(Vl,"SPAN",{});var Hl=i(Ka);v(Tt.$$.fragment,Hl),Hl.forEach(t),Vl.forEach(t),jn=_(lr),Qa=n(lr,"SPAN",{});var Yl=i(Qa);Pn=s(Yl,"Resume training from a saved checkpoint"),Yl.forEach(t),lr.forEach(t),ls=_(e),ge=n(e,"P",{});var Aa=i(ge);Sn=s(Aa,"If you want to resume training from any of the saved checkpoints, you can pass the argument "),Xa=n(Aa,"CODE",{});var Wl=i(Xa);Nn=s(Wl,"--resume_from_checkpoint"),Wl.forEach(t),In=s(Aa," to the script and specify the name of the checkpoint you want to use. You can also use the special string "),Za=n(Aa,"CODE",{});var Jl=i(Za);qn=s(Jl,'"latest"'),Jl.forEach(t),Tn=s(Aa," to resume from the last saved checkpoint (the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),Aa.forEach(t),ps=_(e),v(Ct.$$.fragment,e),hs=_(e),ma=n(e,"P",{});var Kl=i(ma);Cn=s(Kl,"This is a good opportunity to tweak some of your hyperparameters if you wish."),Kl.forEach(t),fs=_(e),Ae=n(e,"H3",{class:!0});var pr=i(Ae);Xe=n(pr,"A",{id:!0,class:!0,href:!0});var Ql=i(Xe);eo=n(Ql,"SPAN",{});var Xl=i(eo);v(Rt.$$.fragment,Xl),Xl.forEach(t),Ql.forEach(t),Rn=_(pr),to=n(pr,"SPAN",{});var Zl=i(to);Un=s(Zl,"Inference from a saved checkpoint"),Zl.forEach(t),pr.forEach(t),us=_(e),da=n(e,"P",{});var ep=i(da);On=s(ep,"Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders, and learning rate."),ep.forEach(t),cs=_(e),Ze=n(e,"P",{});var hr=i(Ze);Mn=s(hr,"If you have "),ao=n(hr,"STRONG",{});var tp=i(ao);oo=n(tp,"CODE",{});var ap=i(oo);Ln=s(ap,'"accelerate>=0.16.0"'),ap.forEach(t),tp.forEach(t),zn=s(hr,` installed, use the following code to run
inference from an intermediate checkpoint.`),hr.forEach(t),_s=_(e),v(Ut.$$.fragment,e),ms=_(e),et=n(e,"P",{});var fr=i(et);Gn=s(fr,"If you have "),so=n(fr,"STRONG",{});var op=i(so);ro=n(op,"CODE",{});var sp=i(ro);Bn=s(sp,'"accelerate<0.16.0"'),sp.forEach(t),op.forEach(t),Fn=s(fr," installed, you need to convert it to an inference pipeline first:"),fr.forEach(t),ds=_(e),v(Ot.$$.fragment,e),gs=_(e),je=n(e,"H2",{class:!0});var ur=i(je);tt=n(ur,"A",{id:!0,class:!0,href:!0});var rp=i(tt);no=n(rp,"SPAN",{});var np=i(no);v(Mt.$$.fragment,np),np.forEach(t),rp.forEach(t),Vn=_(ur),io=n(ur,"SPAN",{});var ip=i(io);Hn=s(ip,"Optimizations for different GPU sizes"),ip.forEach(t),ur.forEach(t),$s=_(e),ga=n(e,"P",{});var lp=i(ga);Yn=s(lp,"Depending on your hardware, there are a few different ways to optimize DreamBooth on GPUs from 16GB to just 8GB!"),lp.forEach(t),vs=_(e),Pe=n(e,"H3",{class:!0});var cr=i(Pe);at=n(cr,"A",{id:!0,class:!0,href:!0});var pp=i(at);lo=n(pp,"SPAN",{});var hp=i(lo);v(Lt.$$.fragment,hp),hp.forEach(t),pp.forEach(t),Wn=_(cr),po=n(cr,"SPAN",{});var fp=i(po);Jn=s(fp,"xFormers"),fp.forEach(t),cr.forEach(t),bs=_(e),me=n(e,"P",{});var la=i(me);zt=n(la,"A",{href:!0,rel:!0});var up=i(zt);Kn=s(up,"xFormers"),up.forEach(t),Qn=s(la," is a toolbox for optimizing Transformers, and it includes a "),Gt=n(la,"A",{href:!0,rel:!0});var cp=i(Gt);Xn=s(cp,"memory-efficient attention"),cp.forEach(t),Zn=s(la," mechanism that is used in \u{1F9E8} Diffusers. You\u2019ll need to "),$a=n(la,"A",{href:!0});var _p=i($a);ei=s(_p,"install xFormers"),_p.forEach(t),ti=s(la," and then add the following argument to your training script:"),la.forEach(t),ws=_(e),v(Bt.$$.fragment,e),Es=_(e),va=n(e,"P",{});var mp=i(va);ai=s(mp,"xFormers is not available in Flax."),mp.forEach(t),ys=_(e),Se=n(e,"H3",{class:!0});var _r=i(Se);ot=n(_r,"A",{id:!0,class:!0,href:!0});var dp=i(ot);ho=n(dp,"SPAN",{});var gp=i(ho);v(Ft.$$.fragment,gp),gp.forEach(t),dp.forEach(t),oi=_(_r),fo=n(_r,"SPAN",{});var $p=i(fo);si=s($p,"Set gradients to none"),$p.forEach(t),_r.forEach(t),ks=_(e),he=n(e,"P",{});var $t=i(he);ri=s($t,"Another way you can lower your memory footprint is to "),Vt=n($t,"A",{href:!0,rel:!0});var vp=i(Vt);ni=s(vp,"set the gradients"),vp.forEach(t),ii=s($t," to "),uo=n($t,"CODE",{});var bp=i(uo);li=s(bp,"None"),bp.forEach(t),pi=s($t," instead of zero. However, this may change certain behaviors, so if you run into any issues, try removing this argument. Add the following argument to your training script to set the gradients to "),co=n($t,"CODE",{});var wp=i(co);hi=s(wp,"None"),wp.forEach(t),fi=s($t,":"),$t.forEach(t),Ds=_(e),v(Ht.$$.fragment,e),xs=_(e),Ne=n(e,"H3",{class:!0});var mr=i(Ne);st=n(mr,"A",{id:!0,class:!0,href:!0});var Ep=i(st);_o=n(Ep,"SPAN",{});var yp=i(_o);v(Yt.$$.fragment,yp),yp.forEach(t),Ep.forEach(t),ui=_(mr),mo=n(mr,"SPAN",{});var kp=i(mo);ci=s(kp,"16GB GPU"),kp.forEach(t),mr.forEach(t),As=_(e),rt=n(e,"P",{});var dr=i(rt);_i=s(dr,"With the help of gradient checkpointing and "),Wt=n(dr,"A",{href:!0,rel:!0});var Dp=i(Wt);mi=s(Dp,"bitsandbytes"),Dp.forEach(t),di=s(dr," 8-bit optimizer, it\u2019s possible to train DreamBooth on a 16GB GPU. Make sure you have bitsandbytes installed:"),dr.forEach(t),js=_(e),v(Jt.$$.fragment,e),Ps=_(e),nt=n(e,"P",{});var gr=i(nt);gi=s(gr,"Then pass the "),go=n(gr,"CODE",{});var xp=i(go);$i=s(xp,"--use_8bit_adam"),xp.forEach(t),vi=s(gr," option to the training script:"),gr.forEach(t),Ss=_(e),v(Kt.$$.fragment,e),Ns=_(e),Ie=n(e,"H3",{class:!0});var $r=i(Ie);it=n($r,"A",{id:!0,class:!0,href:!0});var Ap=i(it);$o=n(Ap,"SPAN",{});var jp=i($o);v(Qt.$$.fragment,jp),jp.forEach(t),Ap.forEach(t),bi=_($r),vo=n($r,"SPAN",{});var Pp=i(vo);wi=s(Pp,"12GB GPU"),Pp.forEach(t),$r.forEach(t),Is=_(e),lt=n(e,"P",{});var vr=i(lt);Ei=s(vr,"To run DreamBooth on a 12GB GPU, you\u2019ll need to enable gradient checkpointing, the 8-bit optimizer, xFormers, and set the gradients to "),bo=n(vr,"CODE",{});var Sp=i(bo);yi=s(Sp,"None"),Sp.forEach(t),ki=s(vr,":"),vr.forEach(t),qs=_(e),v(Xt.$$.fragment,e),Ts=_(e),qe=n(e,"H3",{class:!0});var br=i(qe);pt=n(br,"A",{id:!0,class:!0,href:!0});var Np=i(pt);wo=n(Np,"SPAN",{});var Ip=i(wo);v(Zt.$$.fragment,Ip),Ip.forEach(t),Np.forEach(t),Di=_(br),Eo=n(br,"SPAN",{});var qp=i(Eo);xi=s(qp,"8 GB GPU"),qp.forEach(t),br.forEach(t),Cs=_(e),ht=n(e,"P",{});var wr=i(ht);Ai=s(wr,"For 8GB GPUs, you\u2019ll need the help of "),ea=n(wr,"A",{href:!0,rel:!0});var Tp=i(ea);ji=s(Tp,"DeepSpeed"),Tp.forEach(t),Pi=s(wr,` to offload some
tensors from the VRAM to either the CPU or NVME, enabling training with less GPU memory.`),wr.forEach(t),Rs=_(e),ba=n(e,"P",{});var Cp=i(ba);Si=s(Cp,"Run the following command to configure your \u{1F917} Accelerate environment:"),Cp.forEach(t),Us=_(e),v(ta.$$.fragment,e),Os=_(e),ft=n(e,"P",{});var Er=i(ft);Ni=s(Er,"During configuration, confirm that you want to use DeepSpeed. Now it\u2019s possible to train on under 8GB VRAM by combining DeepSpeed stage 2, fp16 mixed precision, and offloading the model parameters and the optimizer state to the CPU. The drawback is that this requires more system RAM, about 25 GB. See "),aa=n(Er,"A",{href:!0,rel:!0});var Rp=i(aa);Ii=s(Rp,"the DeepSpeed documentation"),Rp.forEach(t),qi=s(Er," for more configuration options."),Er.forEach(t),Ms=_(e),$e=n(e,"P",{});var ja=i($e);Ti=s(ja,`You should also change the default Adam optimizer to DeepSpeed\u2019s optimized version of Adam
`),oa=n(ja,"A",{href:!0,rel:!0});var Up=i(oa);yo=n(Up,"CODE",{});var Op=i(yo);Ci=s(Op,"deepspeed.ops.adam.DeepSpeedCPUAdam"),Op.forEach(t),Up.forEach(t),Ri=s(ja," for a substantial speedup. Enabling "),ko=n(ja,"CODE",{});var Mp=i(ko);Ui=s(Mp,"DeepSpeedCPUAdam"),Mp.forEach(t),Oi=s(ja," requires your system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch."),ja.forEach(t),Ls=_(e),wa=n(e,"P",{});var Lp=i(wa);Mi=s(Lp,"8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment."),Lp.forEach(t),zs=_(e),Ea=n(e,"P",{});var zp=i(Ea);Li=s(zp,"Launch training with the following command:"),zp.forEach(t),Gs=_(e),v(sa.$$.fragment,e),Bs=_(e),Te=n(e,"H2",{class:!0});var yr=i(Te);ut=n(yr,"A",{id:!0,class:!0,href:!0});var Gp=i(ut);Do=n(Gp,"SPAN",{});var Bp=i(Do);v(ra.$$.fragment,Bp),Bp.forEach(t),Gp.forEach(t),zi=_(yr),xo=n(yr,"SPAN",{});var Fp=i(xo);Gi=s(Fp,"Inference"),Fp.forEach(t),yr.forEach(t),Fs=_(e),fe=n(e,"P",{});var vt=i(fe);Bi=s(vt,"Once you have trained a model, specify the path to where the model is saved, and use it for inference in the "),ya=n(vt,"A",{href:!0});var Vp=i(ya);Fi=s(Vp,"StableDiffusionPipeline"),Vp.forEach(t),Vi=s(vt,". Make sure your prompts include the special "),Ao=n(vt,"CODE",{});var Hp=i(Ao);Hi=s(Hp,"identifier"),Hp.forEach(t),Yi=s(vt," used during training ("),jo=n(vt,"CODE",{});var Yp=i(jo);Wi=s(Yp,"sks"),Yp.forEach(t),Ji=s(vt," in the previous examples)."),vt.forEach(t),Vs=_(e),ct=n(e,"P",{});var kr=i(ct);Ki=s(kr,"If you have "),Po=n(kr,"STRONG",{});var Wp=i(Po);So=n(Wp,"CODE",{});var Jp=i(So);Qi=s(Jp,'"accelerate>=0.16.0"'),Jp.forEach(t),Wp.forEach(t),Xi=s(kr,` installed, you can use the following code to run
inference from an intermediate checkpoint:`),kr.forEach(t),Hs=_(e),v(na.$$.fragment,e),Ys=_(e),_t=n(e,"P",{});var Dr=i(_t);Zi=s(Dr,"You may also run inference from any of the "),ka=n(Dr,"A",{href:!0});var Kp=i(ka);el=s(Kp,"saved training checkpoints"),Kp.forEach(t),tl=s(Dr,"."),Dr.forEach(t),this.h()},h(){u(f,"name","hf:doc:metadata"),u(f,"content",JSON.stringify(bh)),u(g,"id","dreambooth"),u(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(g,"href","#dreambooth"),u(p,"class","relative group"),u(R,"href","https://arxiv.org/abs/2208.12242"),u(R,"rel","nofollow"),ah(K.src,re="https://dreambooth.github.io/DreamBooth_files/teaser_static.jpg")||u(K,"src",re),u(K,"alt","Dreambooth examples from the project's blog"),u(F,"href","https://dreambooth.github.io"),u(T,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),u(T,"rel","nofollow"),u(I,"href","https://github.com/huggingface/diffusers/tree/main/examples/dreambooth"),u(I,"rel","nofollow"),u(pa,"href","../optimization/xformers"),u(bt,"href","https://github.com/huggingface/accelerate/"),u(bt,"rel","nofollow"),u(kt,"href","https://huggingface.co/datasets/diffusers/dog-example"),u(kt,"rel","nofollow"),u(ua,"href","create_dataset"),u(Oe,"id","finetuning"),u(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Oe,"href","#finetuning"),u(we,"class","relative group"),u(ze,"id","finetuning-with-priorpreserving-loss"),u(ze,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ze,"href","#finetuning-with-priorpreserving-loss"),u(Ee,"class","relative group"),u(jt,"href","https://arxiv.org/abs/2208.12242"),u(jt,"rel","nofollow"),u(Ve,"id","finetuning-the-text-encoder-and-unet"),u(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ve,"href","#finetuning-the-text-encoder-and-unet"),u(ye,"class","relative group"),u(St,"href","https://huggingface.co/blog/dreambooth"),u(St,"rel","nofollow"),u(We,"id","finetuning-with-lora"),u(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(We,"href","#finetuning-with-lora"),u(ke,"class","relative group"),u(ca,"href","./lora#dreambooth"),u(Ke,"id","saving-checkpoints-while-training"),u(Ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ke,"href","#saving-checkpoints-while-training"),u(De,"class","relative group"),u(Qe,"id","resume-training-from-a-saved-checkpoint"),u(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Qe,"href","#resume-training-from-a-saved-checkpoint"),u(xe,"class","relative group"),u(Xe,"id","inference-from-a-saved-checkpoint"),u(Xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Xe,"href","#inference-from-a-saved-checkpoint"),u(Ae,"class","relative group"),u(tt,"id","optimizations-for-different-gpu-sizes"),u(tt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(tt,"href","#optimizations-for-different-gpu-sizes"),u(je,"class","relative group"),u(at,"id","xformers"),u(at,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(at,"href","#xformers"),u(Pe,"class","relative group"),u(zt,"href","https://github.com/facebookresearch/xformers"),u(zt,"rel","nofollow"),u(Gt,"href","https://facebookresearch.github.io/xformers/components/ops.html#module-xformers.ops"),u(Gt,"rel","nofollow"),u($a,"href","./optimization/xformers"),u(ot,"id","set-gradients-to-none"),u(ot,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ot,"href","#set-gradients-to-none"),u(Se,"class","relative group"),u(Vt,"href","https://pytorch.org/docs/stable/generated/torch.optim.Optimizer.zero_grad.html"),u(Vt,"rel","nofollow"),u(st,"id","16gb-gpu"),u(st,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(st,"href","#16gb-gpu"),u(Ne,"class","relative group"),u(Wt,"href","https://github.com/TimDettmers/bitsandbytes"),u(Wt,"rel","nofollow"),u(it,"id","12gb-gpu"),u(it,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(it,"href","#12gb-gpu"),u(Ie,"class","relative group"),u(pt,"id","8-gb-gpu"),u(pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(pt,"href","#8-gb-gpu"),u(qe,"class","relative group"),u(ea,"href","https://www.deepspeed.ai/"),u(ea,"rel","nofollow"),u(aa,"href","https://huggingface.co/docs/accelerate/usage_guides/deepspeed"),u(aa,"rel","nofollow"),u(oa,"href","https://deepspeed.readthedocs.io/en/latest/optimizers.html#adam-cpu"),u(oa,"rel","nofollow"),u(ut,"id","inference"),u(ut,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ut,"href","#inference"),u(Te,"class","relative group"),u(ya,"href","/docs/diffusers/pr_2352/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),u(ka,"href","#inference-from-a-saved-checkpoint")},m(e,l){a(document.head,f),h(e,d,l),h(e,p,l),a(p,g),a(g,D),b(S,D,null),a(p,x),a(p,U),a(U,W),h(e,O,l),b(M,e,l),h(e,j,l),h(e,G,l),a(G,R),a(R,ee),a(G,ue),h(e,J,l),h(e,L,l),a(L,K),h(e,Q,l),h(e,B,l),a(B,te),a(B,F),a(F,V),h(e,H,l),h(e,N,l),a(N,ce),a(N,T),a(T,z),a(z,_e),a(N,ae),a(N,I),a(I,oe),a(N,m),h(e,k,l),h(e,X,l),a(X,C),a(X,q),a(q,ve),a(X,be),h(e,de,l),b(se,e,l),h(e,ne,l),h(e,Z,l),a(Z,xr),a(Z,pa),a(pa,Ar),a(Z,jr),h(e,To,l),h(e,Ce,l),a(Ce,Pr),a(Ce,bt),a(bt,Sr),a(Ce,Nr),h(e,Co,l),b(wt,e,l),h(e,Ro,l),h(e,ha,l),a(ha,Ir),h(e,Uo,l),b(Et,e,l),h(e,Oo,l),h(e,fa,l),a(fa,qr),h(e,Mo,l),b(yt,e,l),h(e,Lo,l),h(e,Re,l),a(Re,Tr),a(Re,kt),a(kt,Cr),a(Re,Rr),h(e,zo,l),b(Dt,e,l),h(e,Go,l),h(e,Ue,l),a(Ue,Ur),a(Ue,ua),a(ua,Or),a(Ue,Mr),h(e,Bo,l),h(e,we,l),a(we,Oe),a(Oe,Na),b(xt,Na,null),a(we,Lr),a(we,Ia),a(Ia,zr),h(e,Fo,l),b(Me,e,l),h(e,Vo,l),b(Le,e,l),h(e,Ho,l),h(e,Ee,l),a(Ee,ze),a(ze,qa),b(At,qa,null),a(Ee,Gr),a(Ee,Ta),a(Ta,Br),h(e,Yo,l),h(e,Ge,l),a(Ge,Fr),a(Ge,jt),a(jt,Vr),a(Ge,Hr),h(e,Wo,l),h(e,Be,l),a(Be,Yr),a(Be,Ca),a(Ca,Wr),a(Be,Jr),h(e,Jo,l),b(Fe,e,l),h(e,Ko,l),h(e,ye,l),a(ye,Ve),a(Ve,Ra),b(Pt,Ra,null),a(ye,Kr),a(ye,Ua),a(Ua,Qr),h(e,Qo,l),h(e,ie,l),a(ie,Xr),a(ie,Oa),a(Oa,Zr),a(ie,en),a(ie,Ma),a(Ma,tn),a(ie,an),a(ie,St),a(St,on),a(ie,sn),h(e,Xo,l),b(He,e,l),h(e,Zo,l),h(e,le,l),a(le,rn),a(le,La),a(La,nn),a(le,ln),a(le,za),a(za,pn),a(le,hn),a(le,Ga),a(Ga,fn),a(le,un),h(e,es,l),b(Ye,e,l),h(e,ts,l),h(e,ke,l),a(ke,We),a(We,Ba),b(Nt,Ba,null),a(ke,cn),a(ke,Fa),a(Fa,_n),h(e,as,l),h(e,Je,l),a(Je,mn),a(Je,ca),a(ca,dn),a(Je,gn),h(e,os,l),h(e,De,l),a(De,Ke),a(Ke,Va),b(It,Va,null),a(De,$n),a(De,Ha),a(Ha,vn),h(e,ss,l),h(e,_a,l),a(_a,bn),h(e,rs,l),b(qt,e,l),h(e,ns,l),h(e,pe,l),a(pe,wn),a(pe,Ya),a(Ya,En),a(pe,yn),a(pe,Wa),a(Wa,kn),a(pe,Dn),a(pe,Ja),a(Ja,xn),a(pe,An),h(e,is,l),h(e,xe,l),a(xe,Qe),a(Qe,Ka),b(Tt,Ka,null),a(xe,jn),a(xe,Qa),a(Qa,Pn),h(e,ls,l),h(e,ge,l),a(ge,Sn),a(ge,Xa),a(Xa,Nn),a(ge,In),a(ge,Za),a(Za,qn),a(ge,Tn),h(e,ps,l),b(Ct,e,l),h(e,hs,l),h(e,ma,l),a(ma,Cn),h(e,fs,l),h(e,Ae,l),a(Ae,Xe),a(Xe,eo),b(Rt,eo,null),a(Ae,Rn),a(Ae,to),a(to,Un),h(e,us,l),h(e,da,l),a(da,On),h(e,cs,l),h(e,Ze,l),a(Ze,Mn),a(Ze,ao),a(ao,oo),a(oo,Ln),a(Ze,zn),h(e,_s,l),b(Ut,e,l),h(e,ms,l),h(e,et,l),a(et,Gn),a(et,so),a(so,ro),a(ro,Bn),a(et,Fn),h(e,ds,l),b(Ot,e,l),h(e,gs,l),h(e,je,l),a(je,tt),a(tt,no),b(Mt,no,null),a(je,Vn),a(je,io),a(io,Hn),h(e,$s,l),h(e,ga,l),a(ga,Yn),h(e,vs,l),h(e,Pe,l),a(Pe,at),a(at,lo),b(Lt,lo,null),a(Pe,Wn),a(Pe,po),a(po,Jn),h(e,bs,l),h(e,me,l),a(me,zt),a(zt,Kn),a(me,Qn),a(me,Gt),a(Gt,Xn),a(me,Zn),a(me,$a),a($a,ei),a(me,ti),h(e,ws,l),b(Bt,e,l),h(e,Es,l),h(e,va,l),a(va,ai),h(e,ys,l),h(e,Se,l),a(Se,ot),a(ot,ho),b(Ft,ho,null),a(Se,oi),a(Se,fo),a(fo,si),h(e,ks,l),h(e,he,l),a(he,ri),a(he,Vt),a(Vt,ni),a(he,ii),a(he,uo),a(uo,li),a(he,pi),a(he,co),a(co,hi),a(he,fi),h(e,Ds,l),b(Ht,e,l),h(e,xs,l),h(e,Ne,l),a(Ne,st),a(st,_o),b(Yt,_o,null),a(Ne,ui),a(Ne,mo),a(mo,ci),h(e,As,l),h(e,rt,l),a(rt,_i),a(rt,Wt),a(Wt,mi),a(rt,di),h(e,js,l),b(Jt,e,l),h(e,Ps,l),h(e,nt,l),a(nt,gi),a(nt,go),a(go,$i),a(nt,vi),h(e,Ss,l),b(Kt,e,l),h(e,Ns,l),h(e,Ie,l),a(Ie,it),a(it,$o),b(Qt,$o,null),a(Ie,bi),a(Ie,vo),a(vo,wi),h(e,Is,l),h(e,lt,l),a(lt,Ei),a(lt,bo),a(bo,yi),a(lt,ki),h(e,qs,l),b(Xt,e,l),h(e,Ts,l),h(e,qe,l),a(qe,pt),a(pt,wo),b(Zt,wo,null),a(qe,Di),a(qe,Eo),a(Eo,xi),h(e,Cs,l),h(e,ht,l),a(ht,Ai),a(ht,ea),a(ea,ji),a(ht,Pi),h(e,Rs,l),h(e,ba,l),a(ba,Si),h(e,Us,l),b(ta,e,l),h(e,Os,l),h(e,ft,l),a(ft,Ni),a(ft,aa),a(aa,Ii),a(ft,qi),h(e,Ms,l),h(e,$e,l),a($e,Ti),a($e,oa),a(oa,yo),a(yo,Ci),a($e,Ri),a($e,ko),a(ko,Ui),a($e,Oi),h(e,Ls,l),h(e,wa,l),a(wa,Mi),h(e,zs,l),h(e,Ea,l),a(Ea,Li),h(e,Gs,l),b(sa,e,l),h(e,Bs,l),h(e,Te,l),a(Te,ut),a(ut,Do),b(ra,Do,null),a(Te,zi),a(Te,xo),a(xo,Gi),h(e,Fs,l),h(e,fe,l),a(fe,Bi),a(fe,ya),a(ya,Fi),a(fe,Vi),a(fe,Ao),a(Ao,Hi),a(fe,Yi),a(fe,jo),a(jo,Wi),a(fe,Ji),h(e,Vs,l),h(e,ct,l),a(ct,Ki),a(ct,Po),a(Po,So),a(So,Qi),a(ct,Xi),h(e,Hs,l),b(na,e,l),h(e,Ys,l),h(e,_t,l),a(_t,Zi),a(_t,ka),a(ka,el),a(_t,tl),Ws=!0},p(e,[l]){const ia={};l&2&&(ia.$$scope={dirty:l,ctx:e}),Me.$set(ia);const No={};l&2&&(No.$$scope={dirty:l,ctx:e}),Le.$set(No);const Io={};l&2&&(Io.$$scope={dirty:l,ctx:e}),Fe.$set(Io);const qo={};l&2&&(qo.$$scope={dirty:l,ctx:e}),He.$set(qo);const Da={};l&2&&(Da.$$scope={dirty:l,ctx:e}),Ye.$set(Da)},i(e){Ws||(w(S.$$.fragment,e),w(M.$$.fragment,e),w(se.$$.fragment,e),w(wt.$$.fragment,e),w(Et.$$.fragment,e),w(yt.$$.fragment,e),w(Dt.$$.fragment,e),w(xt.$$.fragment,e),w(Me.$$.fragment,e),w(Le.$$.fragment,e),w(At.$$.fragment,e),w(Fe.$$.fragment,e),w(Pt.$$.fragment,e),w(He.$$.fragment,e),w(Ye.$$.fragment,e),w(Nt.$$.fragment,e),w(It.$$.fragment,e),w(qt.$$.fragment,e),w(Tt.$$.fragment,e),w(Ct.$$.fragment,e),w(Rt.$$.fragment,e),w(Ut.$$.fragment,e),w(Ot.$$.fragment,e),w(Mt.$$.fragment,e),w(Lt.$$.fragment,e),w(Bt.$$.fragment,e),w(Ft.$$.fragment,e),w(Ht.$$.fragment,e),w(Yt.$$.fragment,e),w(Jt.$$.fragment,e),w(Kt.$$.fragment,e),w(Qt.$$.fragment,e),w(Xt.$$.fragment,e),w(Zt.$$.fragment,e),w(ta.$$.fragment,e),w(sa.$$.fragment,e),w(ra.$$.fragment,e),w(na.$$.fragment,e),Ws=!0)},o(e){E(S.$$.fragment,e),E(M.$$.fragment,e),E(se.$$.fragment,e),E(wt.$$.fragment,e),E(Et.$$.fragment,e),E(yt.$$.fragment,e),E(Dt.$$.fragment,e),E(xt.$$.fragment,e),E(Me.$$.fragment,e),E(Le.$$.fragment,e),E(At.$$.fragment,e),E(Fe.$$.fragment,e),E(Pt.$$.fragment,e),E(He.$$.fragment,e),E(Ye.$$.fragment,e),E(Nt.$$.fragment,e),E(It.$$.fragment,e),E(qt.$$.fragment,e),E(Tt.$$.fragment,e),E(Ct.$$.fragment,e),E(Rt.$$.fragment,e),E(Ut.$$.fragment,e),E(Ot.$$.fragment,e),E(Mt.$$.fragment,e),E(Lt.$$.fragment,e),E(Bt.$$.fragment,e),E(Ft.$$.fragment,e),E(Ht.$$.fragment,e),E(Yt.$$.fragment,e),E(Jt.$$.fragment,e),E(Kt.$$.fragment,e),E(Qt.$$.fragment,e),E(Xt.$$.fragment,e),E(Zt.$$.fragment,e),E(ta.$$.fragment,e),E(sa.$$.fragment,e),E(ra.$$.fragment,e),E(na.$$.fragment,e),Ws=!1},d(e){t(f),e&&t(d),e&&t(p),y(S),e&&t(O),y(M,e),e&&t(j),e&&t(G),e&&t(J),e&&t(L),e&&t(Q),e&&t(B),e&&t(H),e&&t(N),e&&t(k),e&&t(X),e&&t(de),y(se,e),e&&t(ne),e&&t(Z),e&&t(To),e&&t(Ce),e&&t(Co),y(wt,e),e&&t(Ro),e&&t(ha),e&&t(Uo),y(Et,e),e&&t(Oo),e&&t(fa),e&&t(Mo),y(yt,e),e&&t(Lo),e&&t(Re),e&&t(zo),y(Dt,e),e&&t(Go),e&&t(Ue),e&&t(Bo),e&&t(we),y(xt),e&&t(Fo),y(Me,e),e&&t(Vo),y(Le,e),e&&t(Ho),e&&t(Ee),y(At),e&&t(Yo),e&&t(Ge),e&&t(Wo),e&&t(Be),e&&t(Jo),y(Fe,e),e&&t(Ko),e&&t(ye),y(Pt),e&&t(Qo),e&&t(ie),e&&t(Xo),y(He,e),e&&t(Zo),e&&t(le),e&&t(es),y(Ye,e),e&&t(ts),e&&t(ke),y(Nt),e&&t(as),e&&t(Je),e&&t(os),e&&t(De),y(It),e&&t(ss),e&&t(_a),e&&t(rs),y(qt,e),e&&t(ns),e&&t(pe),e&&t(is),e&&t(xe),y(Tt),e&&t(ls),e&&t(ge),e&&t(ps),y(Ct,e),e&&t(hs),e&&t(ma),e&&t(fs),e&&t(Ae),y(Rt),e&&t(us),e&&t(da),e&&t(cs),e&&t(Ze),e&&t(_s),y(Ut,e),e&&t(ms),e&&t(et),e&&t(ds),y(Ot,e),e&&t(gs),e&&t(je),y(Mt),e&&t($s),e&&t(ga),e&&t(vs),e&&t(Pe),y(Lt),e&&t(bs),e&&t(me),e&&t(ws),y(Bt,e),e&&t(Es),e&&t(va),e&&t(ys),e&&t(Se),y(Ft),e&&t(ks),e&&t(he),e&&t(Ds),y(Ht,e),e&&t(xs),e&&t(Ne),y(Yt),e&&t(As),e&&t(rt),e&&t(js),y(Jt,e),e&&t(Ps),e&&t(nt),e&&t(Ss),y(Kt,e),e&&t(Ns),e&&t(Ie),y(Qt),e&&t(Is),e&&t(lt),e&&t(qs),y(Xt,e),e&&t(Ts),e&&t(qe),y(Zt),e&&t(Cs),e&&t(ht),e&&t(Rs),e&&t(ba),e&&t(Us),y(ta,e),e&&t(Os),e&&t(ft),e&&t(Ms),e&&t($e),e&&t(Ls),e&&t(wa),e&&t(zs),e&&t(Ea),e&&t(Gs),y(sa,e),e&&t(Bs),e&&t(Te),y(ra),e&&t(Fs),e&&t(fe),e&&t(Vs),e&&t(ct),e&&t(Hs),y(na,e),e&&t(Ys),e&&t(_t)}}}const bh={local:"dreambooth",sections:[{local:"finetuning",title:"Finetuning"},{local:"finetuning-with-priorpreserving-loss",title:"Finetuning with prior-preserving loss"},{local:"finetuning-the-text-encoder-and-unet",title:"Finetuning the text encoder and UNet"},{local:"finetuning-with-lora",title:"Finetuning with LoRA"},{local:"saving-checkpoints-while-training",sections:[{local:"resume-training-from-a-saved-checkpoint",title:"Resume training from a saved checkpoint"},{local:"inference-from-a-saved-checkpoint",title:"Inference from a saved checkpoint"}],title:"Saving checkpoints while training"},{local:"optimizations-for-different-gpu-sizes",sections:[{local:"xformers",title:"xFormers"},{local:"set-gradients-to-none",title:"Set gradients to none"},{local:"16gb-gpu",title:"16GB GPU"},{local:"12gb-gpu",title:"12GB GPU"},{local:"8-gb-gpu",title:"8 GB GPU"}],title:"Optimizations for different GPU sizes"},{local:"inference",title:"Inference"}],title:"DreamBooth"};function wh(A){return oh(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jh extends Xp{constructor(f){super();Zp(this,f,wh,vh,eh,{})}}export{jh as default,bh as metadata};
